Fri Mar  2  2012  T Horinouchi
	* gphys-1.2.2 released (cvs tag gphys-1_2_2)
Tue Feb 28  2012  R Mizuta
	* lib/numru/gphys/unumeric.rb: not to use Date#to_datetime
	  + fix for "proleptic_gregorian" calendar. 
Mon Feb 27  2012  T Horinouchi
        * (Added Mar 2) I thought I did the following, but it has not been
	  released:
	  * gphys-1.2.2 released (cvs tag gphys-1_2_2)
	* lib/numru/varraygrib.rb : changed to explicitly raise LoadError
	  if rb-GRIB is not available and VArrayGrib::use_rb_grib is called.
	* lib/numru/ggraph.rb : altered the recently commited test :
	  reduced the numbder of figs; added cliping to polar stereo etc.
	* lib/numru/gphys/assoccoords.rb : debug
	* lib/numru/gphys/unumeric.rb: (for Ruby 1.8) not to use 
	  Date#to_datetime if not defined.
Sun Feb 26  2012  S Otsuka
	* lib/numru/dclext.rb
	  * bugfix in color_bar
	* lib/numru/ggraph.rb
	  * bugfix of map_axes for itr == 10
Fri Feb 24  2012  S Otsuka
	* lib/numru/dclext.rb
	  * bugfix in color_bar for itr >= 10
	* lib/numru/ggraph.rb
	  * test of color_bar for itr = 13..15 and 20..23
Thu Feb 23  2012  T Horinouchi
	* gphys-1.2.1 released (cvs tag gphys-1_2_1)
Tue Feb 21  2012  T Horinouchi
	* install.rb: added again
Tue Feb 21  2012  T Horinouchi
	* gphys-1.2.0 released (cvs tag gphys-1_2_0)
Tue Feb 21  2012  T Horinouchi
	* lib/numru/gphys/grib.rb : class name changed: NumRu::Grib -->
	  NumRu::GPhys::Grib etc
	* lib/numru/gphys/varraygrads.rb: made gphys_grib (NumRu::GPhys::Grib)
	  the default, supported switching between gphys_grib and rb-GRIB
	  (external library)
	* lib/numru/gphys/gphys_io.rb, lib/numru/gphys/gphys_grib_io.rb:
	  Changed accordingly
Mon Feb 20  2012  T Horinouchi
	* gphys_grib_io.rb, gphys_io.rb, varraygrib.rb: previous changes
	  are reverted
	* README : updated
Mon Feb 20  2012  S Nishizawa
	* gphys_grib_io.rb, gphys_io.rb, varraygrib.rb: enable to switch
	  grib library (default is the gphys grib).
	  * to switch it use GPhys::IO.use_gphys_grib or GPhys:IO.use_rb_grib
Mon Feb 20  2012  T Horinouchi
	* README : added a remark on rb-GRIB
	* lib/numru/ggraph.rb : added a colorbar in graph 34 & 36 (itr=5)
	* lib/numru/gphys/grib.rb : not show the warning (... is obsolte).
Mon Feb 20  2012  S Otsuka
	* lib/numru/dclext.rb
	  * bugfix in color_bar for itr = 5, 6
Sun Feb 19  2012  T Horinouchi
	* install.rb: deleted (it has been obsolete since extconf.rb
	  was introduced years ago.)
Sun Feb 19  2012  S Takehiro
	* lib/numru/gphys/gphys_io.rb parse_gturl:
	  * gturl format was changed so as to be able to use "/" 
	    as a separater between path and variable. 
	* bin/ : comments updated according to the change of gturl format. 
Sun Feb 19  2012  T Horinouchi
	* README: udpated
	* lib/numru/gphys/coordmapping.rb: adapted the test part to Ruby 1.9
	* lib/numru/ganalysis/histogram.rb: bugfix
Fri Feb 17  2012  T Horinouchi
        * lib/numru/ganalysis/met.rb: added an option to frontogenesis_func
	* lib/numru/dclext.rb : updated the documentation part
	* doc/ : updated
Thu Feb 16  2012  T Horinouchi
	* lib/numru/dclext.rb DCLExt::flow_vect_anyproj
	  * improved not to show arrows on the baskside when the 
	    projection is multi-valued (map projections)
	  * added handling of NaNs
	  * modified test part
Wed Feb 15  2012  T Horinouchi
	* lib/numru/ggraph.rb (separated DCLExt into the new file dclext.rb)
	* lib/numru/dclext.rb (new file) NumRu::DCLExt is separated from
	  lib/numru/ggraph.rb
Wed Feb 15  2012  T Horinouchi (actually done in Dec 2011)
        * DCLExt::flow_vect_anyproj : added option polar_thinning etc.
Thu Feb 9  2012  S Otsuka
	* lib/numru/ggraph.rb
	  * In GGraph, GPhys#name will be used for the title of a diagram
	    if GPhys#long_name is too long.
	  * tentative workaround in GGraph#color_bar
	* lib/numru/ganalysis/eof.rb
	  * Load rubygems because Ruby/GSL might be installed via rubygems.
Thu Feb 9  2012  R Mizuta
	* lib/numru/gphys/unumeric.rb
	  * bugfix in the method self::from_date with "360_day" calendar.
Fri Feb 3  2012  S Otsuka
	* lib/numru/ggraph.rb
	  * Map projection numbers 16--19 and 34 are enabled.
	    Additional modifications might be needed in future.
	    (DCL 5.4.3 or later is needed to actually use these.)
Fri Feb 3  2012  R Mizuta
	* lib/numru/gphys/grads_gridded.rb, gphys_grads_io.rb:
	    * fixed an error when variable names in grads ctl files 
	      conflict with dimension names (x,y,z,t). 
Wed Feb 1  2012  S Takehiro < S. Nishizawa
	* bin/gpview
	  * added --tonf option.
	* bin/gpvect
	  * added --tonf option.
Tue Jan 31  2012  R Mizuta
	* lib/numru/gphys/unumeric.rb
	  * added support for "proleptic_gregorian" calendar. 
	  * added check for invalid date in "360_day" calendar. 
Tue Jan 24  2012  T Horinouchi
	* commited some enhancement/modification made in Dec 2011
	  * lib/numru/ganalysis/planet.rb
	    * supported boundary condition selection for derivatives (lat_bc)
	    * added some methods (grad_sx, grad_sy, grad_sy_cosphifact,
	      weight_tanphi, weight_cosphi, weight_sinphi)
	  * lib/numru/ganalysis/met.rb
	    * added a method df_dx_vialogscale, to support numerical
	      derivative in log-p coordinate. This is not necessarily
	      an improvement --- it depends on inputs, but the default
	      is tentatively changed to use it.
	    * added new methods: z2geostrophic_wind, frontogenesis_func
Sun Jan  8  2012 S Otsuka
	* lib/numru/ggraph.rb:
	  * default value of LGLOBE in map projections are changed.
	    * when Mercator, LGLOBE becomes true only if the window is
	      almost global.
	  * bugfix in DCLExt#color_bar: when map projection is used
	    in the main plot, ITR was reset when DCLExt.color_bar was called.
Wed Jan  4  2012 S Otsuka
	* lib/numru/gphys/varray.rb: marshal dump and load are implemented.
Thu Dec 24  2011 S Otsuka
	* lib/numru/ganalysis/histogram.rb: bugfix for logarithmic axes.
Thu Dec 22  2011 S Otsuka
	* lib/numru/ggraph.rb: log10_safe and log10_or_0 are defined
	  in order to prevent errors when 0 is given to Math::log10.
	  Math::log10 in color_bar-related functions are substituted
	  with log10_or_0.
	* lib/numru/ganalysis/histogram.rb: bugfix of default window.
Wed Dec  14  2011  T Horinouchi
	* lib/numru/ggraph.rb: Supported vector drawing in any projection
	  (esp. map projection!). It requires a new (yet to come) version
	  of NArrayMiss -- it depends on NArrayMiss#valid? with argument(s).
	  * New methods:
	    * DCLExt::flow_vect_anyproj : flow_vect on any DCL projection.
	      Arrows drawn by this method are properly directed locally
	      (consistent with the local coordinate). Their lengths are
	      proportional to those of the data given. (currently not yet
	      tested with the tranformations 5 and 6, which I'm not used to).
	    * DCLExt::unit_vect_single : for DCLExt::flow_vect_anyproj.
	      Draws only one arrow to express the scaling (by default,
	      upward oriented.)
          * Default change:
	    * GGraph::vector : changed to use flow_vect_anyproj if
	      the current projection number is >= 2. (the method to use
	      can be switched by the new option "flow_vect_anyproj")

Mon Dec  12  2011  T Horinouchi
	* lib/numru/interpolate.rb: debug of mouse_cut: up to the previous
	  version, the end point of the last line segment is not included
	  in the sample points. (So the debug is to cover this end point.)
	* lib/numru/interpolate.rb: debug of  coord_data_reverse :
	  to avoid a side effect on the grid of self.
	* lib/numru/interpolate.rb: Added a new method dcl_fig_cut,
	  which is separated from mouse_cut for use cases without
	  mouse click.
Fri Dec  9  2011  S Otsuka
	* lib/numru/ggraph.rb: xreverse and yreverse will be true
	  when the unit of an axis is compatible with that specified
	  as an option (previously xreverse/yreverse became true
	  only when the unit was exactly the same).
Fri Dec  2  2011  T Horinouchi
	* lib/numru/gphys/gphys.rb: added a new method shape_coerce_full
	  (similar to shape_coerce but possibly expands by replication)
	* lib/numru/interpolate.rb: added a new method coord_data_reverse
	  (reverses the main data (i.e., the dependent variable) and one of the
	  coordinates (an independent variable) through interpolation.)
Thu Dec  1  2011  T Horinouchi
	* lib/numru/interpolate.rb, interpo.c: Supported a behavior
	  not to make extrapolation outside the original grid.
	  Changed the default behavior to this one.
	* lib/numru/interpolate.rb: added a new class method
	  GPhys::extrapolation=(extrapo), where extrapo is true or
	  false --- the default behavior is false, as noted above.
Tue Nov 29  2011  S Nishizawa
	* lib/numru/grib.rb: print message to inform that this grib library is obsoluted.
	* lib/numru/varraygrib: change to find rb-grib library first.
Sun Nov 20  2011  S Takehiro
	* bin/gpview: option --eddy implemented.
	* bin/gpvect: option --eddy implemented.
Fri Nov 11  2011  T Horinouchi
	* lib/numru/ggraph.rb: added 'xloglabelall' and
	  'yloglabelall' to the options of GGraph::axes (to show 
	  lavels for all log-level tick marks)
Thu Nov 03  2011  S Takehiro
	* bin/gpview: option --time_ax implemented.
Fri Oct 28  2011  S Otsuka
	* lib/numru/ganalysis/histogram.rb:
	  * support for itr=2, 3, and 4 in GGraph#histogram.
Tue Oct 18  2011  T Horinouchi
	* lib/numru/ganalysis/planet.rb : 
	  * Changed method name: get_lonlat --> get_lambda_phi. 
	  * method get_lambda_phi: added an optional argument 
	    err_raise (default:true). Changed the order of outputs.
	    Added doc.
	* lib/numru/interpolate.rb: minor reformating of documentation
	* lib/numru/gphys/axis.rb: Axis#cyclic_extendible?: debug
Mon Oct 17  2011  T Horinouchi
	* lib/numru/ganalysis/planet.rb : find_lon_lat_dims: Refined the 
	  criteria
Fri Oct 14  2011  T Horinouchi
	* lib/numru/gphys/derivative.rb: added a new method deriv2nd
	* lib/numru/derivative.rb: added a new method deriv2nd
	  (2nd derivative covering uniform grids)
Sun Sep 04 2011  S Otsuka
	* When max and min of an axis are the same integer value,
	  window values become invalid.
Thu Aug 18  2011  T Horinouchi
	* lib/numru/interpolate.rb: mouse_cut: added optional arguments
	  line_type & line_index, whose default values are 1 & 1,respectively.
Mon Aug 15  2011  T Horinouchi
	* gphys-1.1.1 released (cvs tag gphys-1_1_1)
Thu Aug 11  2011  T Horinouchi
	* LICENCE.txt: Added (BSD 2-clause licence)
	* lib/numru/ggraph.rb: added a method linear_reg_slope_error.
	  --- It may not be a good choice to define this method 
	  here. It is placed here just because it is related with
	  the linear_regression method called in regression_line.
	  In future, methods like this can be moved to another
	  module, so to document it is deliberately avoided.
Sat Jul 29 2011  S Takehiro
	* bin/gpview: option --clrmap fixed. 
Thu Jul 14 2011  S Otsuka
	* lib/numru/gphys/gphys_nusdas_io.rb: Bug fix for assoc_coords.
Fri Jun 24 2011  S Otsuka
	* lib/numru/gphys/gphys_netcdf_io.rb: when variable name is included in
	  the assoc_coord_names, assoc_coords should not be set.
Thu Jun 23 2011  T Horinouchi
	* lib/numru/ggraph.rb: added new options ux_unit and uy_unit,
	  which specify unit vector lengths
Tue Jun  7 2011  T Horinouchi
	* lib/numru/ganalysis/planet.rb : Added a new method grad_s
Tue Jun  7 2011  T Horinouchi < R Mizuta (jun 3)
	* lib/numru/gphys/subsetmapping.rb: bug fix (l.234)

Wed May 11 2011  S Otsuka
	* multibitIO.c: StringValueCStr in rb_str_to_uint*
	  is substituded by StringValuePtr to avoid an error message.
	* lib/numru/gphys/grib.rb: When data were stored from north to south
	  or from east to west, the axes were inconsistent with the data.
Tue Apr 19 2011  S Otsuka
	* lib/numru/ganalysis/histogram.rb: Minimum number of nbins
	  is increased from 1 to 10 when not specified.
Sat Mar 19 2011  T Horinouchi
	* lib/numru/ganalysis/eof.rb: Updated an error message
Fri Mar 18 2011  T Horinouchi
	* ggraph.rb: Added a method regression_line.
	  (((CAUTION: This will fully work in combination with a future
	  NArrayMiss version newer than 1.2.1. Currently,
	  to feed it data with missing will cause an error.)))

Tue Mar 15 2011  T Horinouchi
	* lib/numru/gphys/gphys_fft.rb: a refactoring to deal with
	  a syntax change (or a BUG??) in Ruby 1.9.2 (compared with 
	  Ruby 1.8) regarding multiple assignments in one line
	  using the "[]=" method.
	
Fri Feb 25 2011  T Horinouchi
	* gphys-1.1.0 released (cvs tag gphys-1_1_0)
	* lib/numru/gphys/unumeric.rb: added treatment for
	  two- and one-digit years: to always interpret them as
	  00\d\d etc., not 20\d\d or 19\d\d (as in Date of Ruby 1.9), 
	  regardless Ruby versions.
	* documents updated.
Tue Feb 22 2011  T Koshiro
	* multibitIO.c: ruby 1.9.2 compatibility
Mon Feb 21 2011  T Koshiro
	* ggraph.rb: Added an option 'tonb' to GGraph.tone
Thu Feb 17 2011  T Horinouchi
	* lib/numru/ganalysis/met.rb : Added an RDoc documentation.
Sat Feb 12 2011  T Horinouchi
	* added new files lib/numru/ganalysis/planet.rb
	  and lib/numru/ganalysis/met.rb (created in Jan, actually).
	  * They define modules NumRu::GAnalysis::Planet and
	    NumRu::GAnalysis::Met, unlike other files in GAnalysis
	    that define module functions directory under GAnalysis.
	  * So far, these modules have only limited capabilities.
	    (lead by my own necessity)
	* lib/numru/ganalysis.rb: modified to require these files.
Wed Jan 19 2011  T Horinouchi
	* interpo.c: debug to prevent invalid array access
Tue Jan 18 2011  T Horinouchi
	* lib/numru/gphys/assoccoords.rb: added attr_reader :axlens.
	  Introduced legnth consistency check in the constructor.
	* lib/numru/gphys/grid.rb: Grid#set_assoc_coords: Added
	  legnth consistency check.
Mon Jan 17 2011  T Horinouchi
	* lib/numru/derivative.rb: Supported cyclic extension etc.
	* lib/numru/gphys/derivative.rb: Supported cyclic extension etc
	  (with an option to automatically judge whether cyclic).
	  Unified codes of cderiv and threepoint_O2nd_deriv.
	  Added a new optional argument 'altcoord' to them.
	* lib/numru/gphys/varray.rb: add a method axis_cyclic_extendible?
	* lib/numru/gphys/axis.rb: add a method cyclic_extendible?
Mon Jan 17 2011  T Horinouchi
	* lib/numru/ggraph.rb: added a new option map_rsat to the fig
	  method. This parameter sets RSAT of DCL's SGPPACK for itr==30.
	* lib/numru/gphys/gphys_fft.rb: made new methods:
	  phase_velocity_filter, phase_velocity_binning, and
	  phase_velocity_binning_iso_norml.
Fri Jan 14 2011  S Takehiro < T Tanigawa
	* bin/gpview: option --operation implemented
Thu Jan 13 2011  S Otsuka
	* lib/numru/gphys/gphys_nusdas_io.rb: z* levels are computed 
	  and added to assoc_coords
Wed Oct  6 2010  S Nishizawa
	* lib/numru/ganalysis/eof.rb: changed to sort eof modes with eigen value when GSL is used
Wed Oct  6 2010  S Nishizawa
	* lib/numru/ganalysis/eof.rb: added rdoc document for #eof method
Tue Oct  5 2010  S Otsuka
	* lib/numru/ganalysis/covariance.rb: missing value was not correctly treated.
	* lib/numru/ggraph.rb: the function to display EOF modes is moved to 
	  a new method add_mode_vectors.
Tue Oct  5 2010  T Horinouchi
	* lib/numru/gphys/gphys.rb: added methods set_lost_axes
	  and add_lost_axes, which are redirected to @grid.
	* interpolate.rb: to inherit the lost_axes info
	* lib/numru/ggraph.rb:
	  * test part : added a sample plot of color_scatter;
	    changed to show page numbers
	  * GGraph::scatter, GGraph::color_scatter : modified
	    not to loose the lost_axes info.
Mon Oct  4 2010  S Otsuka
	* lib/numru/ganalysis/eof.rb: a new function eof2 is added.
Mon Oct  4 2010  T Horinouchi
	* lib/numru/ggraph.rb: added sample plots of GGraph::scatter

Mon Sep 13 2010  S Otsuka
	* lib/numru/ggraph.rb: scatter / color_scatter are modified
	  to use all elements in gphys objects (not the first 1D).
	  color_scatter is modified to use DCL::uemrkz.
	  Additional functions (displaying EOF modes and 
	  correlation coefficient) for scatter / color_scatter are
	  copied from the scatter method in Gfdnavi (experimental).
	* lib/numru/ganalysis/covariance.rb: a typo is fixed.
	* README: the install guide is updated.
Tue Sep  7 2010  T Horinouchi	
	* doc/: updated
	* lib/numru/ggraph.rb: document updated
Mon Sep  6 2010  S Otsuka
	* lib/numru/gphys/gphys_io_common.rb: fix a
	  bug in each_along_dims_write which occurs when
	  more than two files are specified for output.
Wed Aug  4 2010  T Horinouchi	
	* lib/numru/gphys/unumeric.rb: added class methods
	  supported_calendar? and supported_calendars
	* lib/numru/ggraph.rb: not to show calendar-based axes
	  if the time variable has the attribute "calendar"
	  and its value is not suppored in UNumeric.
Wed Aug  4 2010  T Horinouchi	
	* lib/numru/gphys/unumeric.rb: UNumeric#to_datetime,
	  UNumeric::from_date: changed to return nil, rather
	  than to raise an exception, if the calendar speficied is 
	  not supported
	* lib/numru/gphys/axis.rb: Axis#[]:
	  to handle nil from UNumeric#to_datetime when @@humane_message
	* lib/numru/gphys/gtool3.rb: Gtool3#interpret_time_axis:
	  to handle nil from UNumeric#to_datetime
Mon Aug  2 2010  T Horinouchi	
	* lib/numru/gphys/unumeric.rb: added "gregorian" and "standard"
	  as synonims of the default calendar (case when nil -->
	  case when nil, "gregorian", "standard").
Tue Jul 27 2010  T Horinouchi	
* lib/numru/gphys/unumeric.rb : correction for Ruby 1.9:
	  to deal with a new feature of DateTime#parse, which interprets
	  1- or 2-digit years (e.g. 1, 02) as in 2000's (e.g., 2001, 2002
	  -- In Ruby 1.8, these were simply interpreted as years
	  1 and 2, which is the behavior we need.)
Wed Jul 21 2010  S Nishizawa
	* lib/numru/ganalysis/eof.rb
	  * changes for update of ruby-lapack
	  * change options
Fri Jul 16 2010  Y SASAKI
	* bin/gpview, bin/gpvect: add option "--clrmap" to select 
	  colormap.
Mon Jun 28 2010  T Horinouchi
	* interpo.c: debug -- multi-dimensional 1D interpolation.
	  * interpo_find_loc_1D_MD: for dimc < rank-1
	  * interpo_do: index counting for mtyp>=3
Tue May 18 2010  S Otsuka
	* lib/numru/ganalysis/histogram.rb : Some parameters added 
	  for 1D histogram.
Mon May 17 2010  T Horinouchi
	* lib/numru/gphys/assoccoords.rb : slight change to suppress
	  a warning in a (sub?) version of ruby 1.8.7
Wed Apr 21 2010  T Horinouchi
	* interpo.c: made "find loc" methods available outside GPhys as 
	  class methods (interpo_find_loc_1D, interpo_find_loc_1D_MD).
Sun Apr 04 2010  S Nishizawa
	* multibitIO.c : add String#to_uint{1,2,3} methods
	* lib/numru/gphys/grib.rb : change to use String#to_uint{1,2,3}
Wed Mar 31 2010  S Nishizawa
	* multibitIO.c
	  * raise exception when input file name is invalid
	  * fix memory leak
	* lib/numru/gphys/grib.rb : changed to use MultibitIO
Wed Mar 31 2010  T Horinouchi
	* multibitIO.c : changed: module MultibitIO -> class MultibitIO
	* test/test_multibitIO.rb : changed accordingly
Tue Mar 30 2010  T Horinouchi
	* multibitIO.c : newly added. IO of multibit numbers. Defines
	  a module MultibitIO and its module function read2D.
	* test/test_multibitIO.rb : a sample source to use MultibitIO
	* test/mltbit.dat : test data used by test_multibitIO.rb
	* ext_init.c : updated to the initializer in multibitIO.c
Thu Mar 26 2010  T Horinouchi
	* lib/numru/gphys/grib.rb: changed the type of narray to read
	  in: float (=double) -> sfloat
Sat Mar 20 2010  S Nishizawa
	* lib/numru/gphys.grib.rb: modification for efficiency
Thu Mar 16 2010  S Nishizawa
	* lib/numru/gphys/grib.rb: "hoge".hex to 0xhoge
	* lib/numru/gphys/grib_params.rb: add variable of VBDSF (No.166) to the JMA table
Mon Mar 15 2010  T Horinouchi
	* lib/numru/gphys/grib.rb: update for Ruby 1.9
	  (in response to a change in String#[])
Fri Feb 26 2010  S Otsuka
	* lib/numru/ggraph.rb: bugfix on options in tone_and_contour
Mon Feb 21 2010  T Horinouchi
        * gphys-1.0.0 re-released (sory about that)
        * install.rb added again after removal
Fri Feb 19 2010  T Horinouchi
	* gphys-1.0.0 released (cvs tag gphys-1_0_0)
Fri Feb 19 2010  R Mizuta
	* lib/numru/gphys/grads_gridded.rb: speed up of reading file
Fri Feb 19 2010  T Horinouchi
	* lib/numru/gphys/gphys.rb : added a new method GPhys#eddy
	  (which must have been frequently defined by users :-p )
	* install.rb : removed from repository
	* lib/numru/interpolate.rb: cleaned up (removed unnecesary comment-
	  outs)
Thu Feb 18 2010  T Horinouchi
	* lib/numru/interpolate.rb: GPhys#interpolate supported data missing
	* interpo.c: interpo_do (c_interpo_do) supported data missing
Thu Feb 18 2010  T Horinouchi
	* lib/numru/interpolate.rb:
	  * added a new method GPhys#regrid
	  * GPhys#interpolate: supported conversion of coordinate units
Thu Feb 18 2010  T Horinouchi
	* lib/numru/gphys/varraycomposite.rb : VArrayComposite#val changed
	  not to depend on ntype
	* lib/numru/gphys/gphys.rb : GPhys.each_along_dims changed
	  not to depend on ntype
        * lib/numru/ggraph.rb: GGraph::level_chval_fmt improved judgement 
	  of least_order
Thu Feb 11 2010  T Horinouchi
	* lib/numru/interpolate.rb: very minor change
Wed Feb 10 2010  T Horinouchi
	* lib/numru/gphys/assoccoords.rb : minor change in AssocCoords#merge 
Fri Feb  5 2010  T Horinouchi
	* sample/ncep_theta_coord.rb : [newly added] a sample
	  of GPhys#interpolate
	* lib/numru/dcl_mouse.rb: [newly added] defines classes
	  DCLMousePt and DCLMouseLine to capture mouse click on
	  the DCL viewport.
	* lib/numru/interpolate.rb: 
	  * added new methods GPhys#mouse_cut GPhys#mouse_cut_repeat
	    * mouse_cut: makes a subset interactively by specifying 
	      a (poly-)line on the DCL window
	    * mouse_cut_repeat: interpolation onto grid points 
	      specified by the previous call of GPhys#mouse_cut
	  * minor change in dimension ordering.
	  * to accept values with missing (but data missing treatment
	    has not been supported -- currently just ignored).
	* interpo.c: debug
	* lib/numru/gphys/grid.rb: set_axis was changed to renew the axis name
Thu Feb  4 2010  T Horinouchi
	* lib/numru/interpolate.rb, interpo.c: coverage broadened / debug
Mon Feb  1 2010  T Horinouchi
	* lib/numru/interpolate.rb: [newly added] defines 
	  a new method GPhys#interpolate in a separate file.
	  (Wide-purpose multi-dimensional linear interpolation)
	* interpo.c: [newly added] C extension to support 
	  GPhys#interpolate. This file provides only private methods.
	* ext_init.c: Modfied to call the initiation method in 
	  interpo.c.
	* lib/numru/gphys.rb: Modified to require numru/gphys/interpolate;
	  Also, to require numru/gphys_ext is made mandatory (from optional).

Fri Jan 29 2010  T Horinouchi
	* lib/numru/grid.rb: added a new method coord_dim_indices
	  (test part is written in lib/numru/assoccoords.rb)

Wed Jan 13 2010  T Horinouchi
        * lib/numru/ggraph.rb: added a new method color_scatter
	  (to draw a scatter diagram colored by values)

Tue Jan 05 2010  T Horinouchi
        * lib/numru/ggraph.rb: added a new method scatter
	  (to draw a scatter diagram)

Wed Sep 30 2009  S Takehiro
        * bin/gpvect: option --nocolorbar and --nozero added.
Fri Aug  7 2009 M Horikawa
        * lib/numru/gphys/gphys_hdfeos5_io.rb: _sw_open bug fix
        * lib/numru/ggraph.rb: profile,timeplot were modified.
Wed Jul 29 2009 S Otsuka
	* lib/numru/gphys/grads_gridded.rb: bug fix (the previous version could not interpret a specific expression of TDEF in GrADS ctl such as 12Z30APR2008)
	
Mon Jul 27 2009 T Koshiro
	* lib/numru/ggraph.rb: DCLExt.color_bar
	  * added a new option "inffact": to specify the factor to change the
	    length of triangle on the side for infinity (relative to 'vwidth').
	  * added a new option "units_voff" and "title_voff": to specify the
	    offset value from the default position in the V coordinate.
	  * changed default position of units and default character size of
	    title.
	  * bug fix for "log"=>true.

Wed Jul 22 2009 S Otsuka
	* lib/numru/gphys/gphys_nusdas_io.rb: bug fix
	
Wed Jul  8 2009 T Koshiro
	* lib/numru/ggraph.rb: GGraph::axes
	  options "xmaplabel","ymaplabel": default values are changed

Thu Jul  2 2009 T Horinouchi
	* gphys-0.7.0 re-released (cvs tag gphys-0_7_0)
	* lib/numru/gphys/narray_ext.rb : _dump / _load implementation
	  was modified.
Thu Jul  2 2009 T Horinouchi
	* gphys-0.7.0 released (cvs tag gphys-0_7_0)
	* lib/numru/gphys/gphys.rb : made the #marshal_load and 
	  #marshal_dump methods public. Added test code of them
	* lib/numru/gphys/narray_ext.rb : Newly created. To support
	  marshaling.

Thu Jul  2 2009 S Nishizawa
	* lib/numru/gphys/gphys.rb : add #marshal_load and #marshal_dump methods

Thu Jul  2 2009 T Horinouchi
	* lib/numru/vizshot.rb : removed (moved into the new
	  project gfdnavi_utils)

Wed Jul  1 2009 T Horinouchi
	* lib/numru/gphys/gtoo3.rb, varraygtool3.rb : minor bug fix
	* lib/numru/ggraph.rb : added the "auto" option to GGraph::tone
	* lib/numru/gphys.rb : to require "gphys_ext" if installed

Mon May 18 2009 S Otsuka
	* lib/numru/gphys/varraynetcdf.rb:
	  a bug fix to prevent endless loop
	
Wed May  6 2009 R Mizuta
	* lib/numru/gphys/grads_gridded.rb:
	  tentatibe support for "pdef"
Tue Apr 28 2009 A tomobayashi
        * lib/numru/gphys/gphys_hdfeos5_io.rb:
          enable to read Zonal Average structure.
        * lib/numru/gphys/varrayhdfeos5.rb:
          make a new class "VArrayHE5ZaField".

Mon Apr 27 2009  T Horinouchi
	* lib/numru/gphys/gphys_io.rb: added a new method 
	  GPhys::IO.str2gphys.
	* lib/numru/ggraph.rb: 
	  * ggraph methods (contour etc): enhanced to accept strings
	    to specify a GPhys -- Longer need to call GPhys::IO.open
	    in advance
	  * ggraph methods (contour etc): added new options "slice",
	    "cut", and "mean" -- this is to supplement the enhancement 
	    above. Also, one can unify subsetting calls for the 2 
	    vector components.
	  * eliminated unsed options (don't know why they are introduced)
	  * tone: added the "color_bar" option for quick look.
	    -- for full control, you should still use GGraph.color_bar
	    separately.

Mon Apr 27 2009  T Horinouchi
	* Added a gtool3 support
	  * Added files: gtool3.rb, gphys_gtool3_io.rb, gphys_gtool3_io.rb
	    (in lib/numru/gphys/)
	    * Note: gtool3.rb is in pure Ruby. Though it's reasonably 
	      fast, in future I would like to have a C-extension 
	      library that generally handles regularly structured
	      binary files (incl. fortran unformatted files)
	      as a common low-level library for GrADS, GRIB, etc. 
	  * lib/numru/gphys/gphys_io.rb: added the Gtool3 support.
	
Mon Apr 23 2009 A tomobayashi
	* lib/numru/gphys/gphys_hdfeos5_io.rb:
	  * remove "Regexp" from error message in __interpret_files method.
Mon Apr 23 2009 A tomobayashi
	* lib/numru/gphys/varrayhdfeos5.rb:
	  * replace get_att_names method to att_names.
Mon Apr 20 2009 A tomobayashi
	* lib/numru/gphys/gphys_hdfeos5_io.rb:
	  * corrected an error message for truely multidimensional longitudes/latitudes.
	  * has_swath? and has_grid? methods come to be used again.
Thu Apr 16 2009 A tomobayashi
	* lib/numru/gphys/gphys_hdfeos5_io.rb:
	  corrected how to select variables for making axes in reading grid structure.
Mon Apr 13  2009  T Horinouchi
	* lib/numru/gphys/attribute.rb: made the methods merge and update 
	  public
	* lib/numru/gphys/varray.rb, lib/numru/gphys/varraycomposite.rb
	  * debug : TypeErroor --> TypeError in a raise call 
	    (varray.rb)
	  * minor change in a private method __ntype (to take typecode
	    directly as the argument rather than to call arg.typpecode
	    inside) (varray.rb, varraycomposite.rb)
Tue Apr  7  2009  A Tomobayashi
        * lib/numru/gphys/gphys_hdfeos5_io.rb:
          enable to read Grid structure.
        * lib/numru/gphys/varrayhdfeos5.rb:
          make a new class "VArrayHE5GdField".
Thu Mar  6  2009  M Horikawa
        * changed struct HE5SwField (VALUE file -> VALUE swath)
Tue Jan 20  2009  R Mizuta
    * lib/numru/gphys/axis.rb, unumeric.rb, grads_gridded.rb: 
      support 365_day calendar (i.e. no leap year) for NetCDF and GrADS
    * lib/numru/ggraph.rb: 
      support 365_day calendar for time axis
Sun Dec 14  2008  S Takehiro
	* bin/gpview: --mark option implemented
Fri Aug 01  2008  S Otsuka
	* lib/numru/ggraph.rb: ruby 1.9 compatibility
Mon Jul 14  2008  T Horinouchi
	* lib/numru/gphys/varrayhdfeos5.rb: to use HE5SwField#get_att
	  instead of HE5SwField#att (which was deprecated).
Thu Jul 17  2008  S Otsuka
	* extconf.rb: code for cygwin added.
Thu Jul 17  2008  S Otsuka
	* lib/numru/gphys/attribute.rb: ruby 1.9 compatibility
Mon Jul 14  2008  T Horinouchi
	* lib/numru/ggraph.rb: definition of @@[line|mark|vector]_options
	  were moved outside the [line|mark|vector] methods.
	* lib/numru/gphys/gphys_hdfeos5_io.rb:
	  * HE5_IO::open (actually HE5_IO::_sw_open) was modified
	    to use AssocCoords
	* lib/numru/gphys/grid.rb: 
	  * deprecated unused methods
	    exclude, change_axis!, insert_axis, insert_axis!
          * added assoc coord support to Grid#transpose
	    Grid#change_axis, Grid#delete_axes
	* lib/numru/gphys/assoccoords.rb: addde a new method
	  AssocCoords#subset_having_axnames
Mon Jul 14  2008  T Horinouchi
	* lib/numru/gphys/grid.rb: added Grid#cut_assoccoord
	* lib/numru/gphys/gphys.rb: GPhys#cut : support assoc coords --
	  when the argument is a Hash, one can specify associated
	  coordinates as well as the regular axes.
	* lib/numru/gphys/assoccoords.rb: addition was made to the test part 
	* lib/numru/ggraph.rb: addition was made to the test part
Sat Jul 12  2008  T Horinouchi
	* lib/numru/gphys/varrayhdfeos5.rb : VArrayHE5SwField#shape
	  was improved in response to the debug of ruby-hdfeos5
Sat Jul 12  2008  T Horinouchi
	* lib/numru/gphys/netcdf_convention.rb : started CF convention
	  support, which is set to be the default convention.
	* lib/numru/gphys/gphys_netcdf_io.rb : supported assoc coords
	* lib/numru/gphys/grid.rb,lib/numru/gphys/gphys.rb : minor update
	* lib/numru/gphys/assoccoords.rb: added some methods
	* testdata/assoc_crds.nc : added (renamed output from
	  assoccoords.rb)
Sat Jul 12  2008  T Horinouchi
	* lib/numru/ggraph.rb: 
	  * Refactoring of GGraph::vector :
	    shortened by using axes_or_map_and_ttl.
	  * introduced data_prep_2D and data_prep_1D to do common
	    works in graphic methods.
	  * Many changes to support itr==51
Fri Jul 11  2008  T Horinouchi
	* lib/numru/gphys/grid.rb: 
	  * to use AssocCoords, along with many new methods such as
	    set_assoc_coords
	  * made Grid#coord 
	* lib/numru/gphys/gphys.rb: 
	  * GPhys#coord was changed to simply use Grid#coord
	  * made many methods to be forwared to the new methods of Grid
	  * Changed GPhys#grid to be public (it has been protected),
	    since a grid is not just a container of axes any more.
	    But forwarding will be continued. So basically,
	    it would not be needed to use it.
	* lib/numru/gphys/assoccoords.rb: test part enhanced, etc

Fri Jul  4  2008  T Horinouchi
	* lib/numru/gphys/assoccoords.rb: created -- to support "assocated 
	  coordinates", which can be multi-dimensional.
	* extconf.rb: created
	* ext_coord.c: created -- extension library to speed up coordinate handling
	* ext_init.c: created -- just a starter of extention libraries

Wed Jul  2  2008  T Horinouchi
	* lib/numru/gphys/gphys_hdfeos5_io.rb: 
	  * Introduced PredefCoordNames, from which GPhys::HE5_IO::open
	    select coordinate variables if found. Also, it was
	    changed to look for 1D data fields if no geolocation
	    field for a dimension is found.
	  * Changed according to the recent change in hdfeos5.rb
	    (HE5SwField#dim_names was reversed) 
Tue Jul  1  2008  T Horinouchi
	* lib/numru/gphys/varrayhdfeos5.rb: Changed not to do buffering --
	  This part was for NetCDF, which has the define mode and 
	  the data mode. I do not know whether a similar buffering
	  would be desirable or not.
	* lib/numru/gphys/gphys_hdfeos5_io.rb: 
	  * A minor refactoring of IO::write
	  * Edited the test part at the bottom of the file
	    * Now it passes!
	    * But, actually, I have commented out a latter half of it.
Tue Jul  1  2008  T Horinouchi
	* lib/numru/gphys/gphys_hdfeos5_io.rb: 
	  * Refactoring of HE5_IO::open -- the behavior should
	    be identical, but the source has got much shorter.
	    (This is to prepare for modification to improve.)
	  * Refactoring of HE5_IO::open : Division was made for 
	    each grid type. Now the main part of the old open
	    is separated in the private method _sw_open
Tue Jul  1  2008  T Horinouchi
	* lib/numru/gphys/gphys_hdfeos5_io.rb: 
	  * change due to a debug of hdfeos5.rb (swath_names? --> swath_names)
	  * Changed the delimiter between swath names and variable names
	    from "." to "/"
	* lib/numru/gphys/gphys_io.rb:
	  * file2type : to support HE5Sw in addition to HE5
Tue Apr 22  2008  T Horinouchi
	* gphys_io.rb: Changed to make the HDF-EOS5 support optional: 
	  get around the load error of the HDF-EOS5 interface 
	  (NumRu::HE5).
Tue Apr 22  2008  M Horikawa
        * lib/numru/gphys/gphys_hdfeos5_io.rb: added for hdfeos5
        * lib/numru/gphys/varrayhdfeos5.rb: added for hdfeos5
        * lib/numru/gphys/gphys_io.rb: modified for hdfeos5
        * lib/numru/ggraph.rb: added new methods profile, timeplot
                            modified @@contour_options, @@tone_options
        * lib/numru/vizshot.rb: added new methods profile, timeplot
Fri Apr  4  2008  T Horinouchi
        * updated doc/
Thu Feb  14  2008  S Takehiro
        * bin/gpview: option --nocolorbar and --nozero added.
	
Thu Mar  1  2008  T Horinouchi
	* gphys-0.6.1 released (cvs tag gphys-0_6_1)
Sun Feb  24  2008  S Otsuka
	* lib/numru/gphys/grads_gridded.rb: ruby 1.9 compatibility on windows
Thu Feb  14  2008  S Takehiro
        * gphys_io.rb: parse_gturl and open_gturl interpret position setting 
	  as grid numbers rather than physical coordinates
	  when the position specifiers begin with "^".
	* gpcommon.rb: copy_global_att can deal with GPhys 
	  which consists of multiple files. 
Tue Feb  12  2008  R Mizuta
        * axis.rb: changes corresponding to the added methods in unumeric.rb
Tue Feb  12  2008  S Nishizawa
	* grib.rb : minor change for better performance
	* gphys_nusdas_io.rb : changes for new version of ruby-nusdas
Mon Feb  11  2008  T Horinouchi
	* unumeric.rb : added a new class method UNumeric::from_date
	  and a method UNumeric#to_datetime. Changed UNumeric#strftime
	  to use UNumeric#to_datetime.
Mon Feb  11  2008  T Horinouchi < R Mizuta
        * axis.rb: Axis#cut : to support Date and DateTime
Mon Feb  11  2008  T Horinouchi
  commited the following changes, which haven't been commited yet
  (latest changes in ggraph.rb were merged):
  Wed Dec 26  2007  T Horinouchi
	* lib/numru/ggraph.rb: GGraph::annotate : added new argument
	  noff (nil=default or Integer) to make it suitable to
	  consecutive (separate) calls
	* axis.rb : added new class methods Axis.strftime_fmt= and
	  Axis.strftime_fmt to specify (or get) the format of strftime
	  used in Axis#[]
	* unumeric.rb : added new method strftime.

Fri Feb  8  2008  S Otsuka
	* install.rb: ruby 1.9 compatibility
	* lib/numru/gphys/axis.rb: ruby 1.9 compatibility
	* lib/numru/gphys/subsetmapping.rb: ruby 1.9 compatibility
	* lib/numru/gphys/gphys_io.rb: ruby 1.9 compatibility
	* lib/numru/gphys/varraycomposite.rb: ruby 1.9 compatibility
	* lib/numru/gphys/grib.rb: ruby 1.9 compatibility
Fri Feb  8  2008  T Koshiro
	* ggraph.rb: DCLExt.color_bar: bug fix for drawing bar frame
Fri Feb  8  2008  T Koshiro
	* ggraph.rb: DCLExt.color_bar: added a new option "labels_ud":
	  to specify user-defined labels for replacing the default labels
	  (Array of String)
Thu Feb  7  2008  T Koshiro
	* ggraph.rb: DCLExt.color_bar: added new options and fixed bugs.
	  * added new option: "title", "units", and "charindex"
	  * no tick lines are drawn if opt["tickintv"] == 0
	  * no labels are drawn if opt["labelintv"] == 0
	  * option "index" is validated for frame and tick lines regardless of opt["constwidth"] setting
	  * fixed the length of the color bar with opt["constwidth"] == true
	  * fixed other small bugs
Wed Jan 30  2008  R Mizuta
	* grads_gridded.rb: bug fix for reading sequential binary file. 
	* varraygrads.rb: minor bug fix for writing control file. 

Tue Dec 25  2007  T Horinouchi
	* lib/numru/ggraph.rb: added new options.
	  * GGraph.fig: eqdistvpt, round0, round1
	  * GGraph.line, GGraph.mark: map_axes
	    * in doing so, introduced a new method axes_or_map_and_ttl,
	      which is now commonly called in contour, tone, mark & line.
Fri Dec 14  2007  S Nishizawa
	* lib/numru/gphys/gphys_nusdas_io.rb: added for nusdas
	* lib/numru/gphys/varraynusdas.rb: added for nusdas
	* lib/numru/gphys/gphys_io.rb: modified for nusdas
Mon Dec  3  2007  T Horinouchi
	* lib/numru/ggraph.rb: improvement in GGraph::fig: To avoid
	  the internally defined DCL window to have xmin==xmax or ymin==ymax.
	* varray.rb: improvement for NArray_type3_methods : not to fail 
	  if the result is nil.
Mon Dec  3  2007  T Horinouchi < S Nishizawa
	* lib/numru/vizshot.rb: revised VizShot#plot not to fail with opendap
Tue Nov 27  2007  T Horinouchi
	* lib/numru/vizshot.rb: supported extensions, thanks to S. Nishizawa
Tue Nov 27  2007  T Horinouchi
	* gphys.rb: added a new method first3D

Thu Oct 25  2007  R Mizuta
	* grads_gridded.rb: bug fix for template in the grads control file. 
Tue Aug 28  2007  T Horinouchi < dennou-ruby:002830
	* ggraph.rb: (debug) DCLExt.color_bar: to call DCL.uwsgxz(false)
	  and DCL.uwsgyz(false) after calling DCL::uwsgxa and DCL::uwsgya.
Thu Aug 16  2007  T Horinouchi
	* gphys-0.6.0 released (cvs tag gphys-0_6_0)
Tue Aug 14  2007  T Horinouchi
	* ggraph.rb: DCLExt::level_chval_fmt : improved the automatic 
	  label-format determination algorithm for |dx|<1e-6
	  (essentially a debug).
Fri Jul 27  2007  T Horinouchi
	* gdir.rb: fixed bugs in list_*_v when called with a path argument.
Thu Jul 26  2007  T Horinouchi
	* gphys_netcdf_io.rb, gphys_io.rb: to make a record in the NetCDF 
	  global attribute 'history' in each_along_dims_write. (Before that,
	  history recording is made only with the write method.)
Thu Jul 26  2007  T Horinouchi
	* gphys_netcdf_io.rb: NetCDF_IO::write : changed to write command 
	  name (File.basename($0)), rather than the method name, to the
	  global attribute 'history'.
Wed Jul 25  2007  T Horinouchi
	* ggraph.rb: improved default color-bar labeling for log-scale:
	  to simply use chval format 'b', rather than using
	  level_chval_fmt, which is optimized for equal spacing.
	* subsetmapping.rb: improved an error message.
Tue Jul 24  2007  T Horinouchi
	* axis.rb: added a new class method Axis.humane_message=
	  to disable the humane messaging by [] (By defalut,
	  lost time axis info is expressed in a chronological
	  yyyy-mm-... form, which may be unwanted.)
	* subsetmapping.rb: to use Array#values_at instead of
	  Array#indices, which is obsolete and warned in Ruby 1.8.
	  (note: Array#values_at is a ruby 1.8 feature.)
	* varray.rb: VArray#val: to support negative array index 
	  with step (by using Hash) for NArray-type data.
Wed Jul 18  2007  Y Morikawa
	* bin/gpedit: Create or overwrite the attributes of a variable 
	  specified by a gtool4-type URL (Only netCDF files are supported).
Tue Jul 17  2007  S Takehiro
        * lib/numru/ggraph.rb: demo for GGraph::vector and 'flow_itr5' option
	  (vector filed plotting on the polar corrdinate) added. 
Tue Jul 6  2007  S Takehiro
        * lib/numru/ggraph.rb: optional branch position of 'flow_itr5' and 
	  'flow_vect' are exchanged in GGraph::vector. 
	  In GGraph::title, action of the case of itr==5 changed. 
	  In flow_itr5, unit_vector option is added. 
	* bin/gpvect: commnad for 2D vector field plotting, optionally with 
	  contour/tone of scalar field newly created. 
Thu Jul 5  2007  R Mizuta
	* grads_gridded.rb: added support for template %m1,%d1,%h1,%h2,%n2 
      in the control file. 
    * lib/numru/dclext_datetime_ax.rb: bug fixed 
      (save and restore x/yfact, x/yoffset)
Tue Jul 4   2007  S Takehiro
        * lib/numru/ggraph.rb: Added a new method DCLExt.flow_itr5 to draw 
	  a 2D vector filed on the polor coordinate. GGraph::vector was 
	  modified to call this method. 
	  GGraph::vector is fixed to perform the axes exchange before 
	  rank inquirey. 
Tue Jun 26  2007  T Horinouchi
	* lib/numru/vizshot.rb: Added a new tone_cont option 
	  "color_bar_options", which takes options of
	  GGraph::color_bar as a Hash. To test it, try the test menu 6 by
	    % ruby vizshot.rb 6
Tue Jun 26  2007  T Horinouchi
	* lib/numru/vizshot.rb: Added a logarithmic color-bar option:
	  * If a GGraph option 'log' is given to VizShot#tone_cont,
	    it was made to be passed to GGraph::color_bar in addition
	    to GGraph::tone etc. 
	    (Therefore, at this moment, only the "log" option
	    of color_bar was supported. I'm also planning to
	    support any color_bar options.)

Mon Jun 25  2007  T Horinouchi
	* axis.rb Axis#[]  
	  * supported units compatible with "months" (e.g.
	    year, pentad) with since fields.
	  * debug and minor improvement of "day"-compatible
	    units (second,hour,...) with since fields, 
	    which was supported on jun 21 2007.

Thu Jun 21  2007  T Horinouchi
	* axis.rb Axis#[] : changed the lost-axis descripting
	  string, when the axis is a time one, whose units
	  has a "since" field. In that case, string to be returned 
	  was changed to a date time in the form of
	  "%Y-%m-%d %M:%H:%S%z" (formatted by strftime).
Thu Jun 21  2007  R Mizuta
	* grads_gridded.rb: error massage when ctl file and binary 
      are inconsistent. 
Thu Jun 21  2007  T Horinouchi
	* ggraph.rb: Added calendar-type time axis support.
	  * Added new option "time_ax" for GGraph::axes, where
	    * nil (defalut): Draws calendar-type time axis if 
	      the unit of an axis is time one with the "since"
	      field (such as "hours since 2006-01-01").
	      Auto selects "h" or "ymd" below, depending on the
	      length of the period (current thres: 5 days).
	    * false: Do not use the time axis regardless the units
	    * 'h': When the units allow (see the description for nil),
	      always use the hour-resolving time axis datetime_ax
	      in dclext_datetime_ax.rb)
	    * 'ymd': When the units allow (see the description for nil),
	      always use the y-m-d type axis using DCL.uc[xy]acl.
Tue May 22  2007  T Horinouchi
	* ggraph.rb: Added a new option 'keep' in GGraph::contour, 
	  GGraph::tone, GGraph:vector (defalut val: false). If its value
	  is set true, the contour levels / tone levels & patterns / 
	  vector scaling, respectively, are set to be the same
	  as in the previous call. GOOD FOR ANIMATION.
	  Also, a minor debug was made in contour -- handling of 'lmsg'
	  in log scaling.
Wed May 9  2007  T Horinouchi
	* gphys.rb: GPhys#average etc (in Axis.defined_operations).
	  debug not to cause error when the result is scalar
	  (to return the scalar itself -- behavior unified with 
	  mean etc)

Tue Apr 24  2007  T Horinouchi
	* varray.rb: debug in replace_val (replace_val was not effective
	  for subset VArray); added explicit error for VArray subclasses
	  such as VArrayNetCDF.
	* gphys_fft.rb: added the second argument replace_val to the class 
	  method fft_ignore_missing
Fri Mar 16  2007  T Horinouchi
	* axis.rb: debuged the error message string at l.646 

Fri Feb 23  2007  T Horinouchi
	* gphys-0.5.4 released (cvs tag gphys-0_5_4)

Mon Dec 12  2006  T Horinouchi
	* gphys_fft.rb: added a class method fft_ignore_missing: this is
	  to set a flag (class variable) to ignore missing values. 
	  This is for data that actually do not have missing 
	  but is treated as potentially having missing (often
	  by having the valid_* attributes of NetCDF.)

Mon Dec 12  2006  T Horinouchi
	* ggraph.rb: 
	  * GGraph.tone,GGraph.contour: Added option 'log'
	  * DCLExt : added new method quasi_log_levels and quasi_log_levels_z
            (driver of quasi_log_levels with data values)
Mon Dec 11  2006  T Horinouchi
	* ggraph.rb: Added options 'legend' etc to GGraph.line and GGraph.mark
	  to annotate the line/mark type and index (and size if mark).
	  ('legend', 'legend_vx', 'legend_dx' (only for line), 'legend_vy', 
          'legend_size') By defualt it is shown in the right margin of vpt.
	  'legend' is a String to show, or true to show the name of the
	  current GPhys object.
	  * DCLExt : added new method legend
Fri Nov 24  2006  T Horinouchi
	* lib/numru/vizshot.rb: debug to allow Regexp in :file & :file2
Wed Oct 11  2006  T Horinouchi
	* ggraph.rb: added documentation for (next|set)_(contour|tone)
Wed Oct 11  2006  T Horinouchi
	* gphys-0.5.3 released (cvs tag gphys-0_5_3)
Wed Oct 11  2006  T Horinouchi
	* ggraph.rb: added new methods set_contour, next_contour,
	  set_tone, and next_tone
	* lib/numru/vizshot.rb: added new methods set_contour and set_tone
Thu Sep  8  2006  T Horinouchi
	* lib/numru/vizshot.rb: added new methods:
	  * VizShot#add : to add plots in another VizShot non-destructively
	    (also added are protected methods 
	    semi_deep_clone, and  plots (attr_reader))
Thu Aug 31  2006  T Horinouchi
	* lib/numru/vizshot.rb <-- lib/numru/easyviz.rb : renamed
	  * changed argument spec in execute and (gen|dump)_code*
Thu Aug 31  2006  T Horinouchi
	* lib/numru/easyviz.rb:
	  * added dump_code
	  * multiple frame support
	  * added replace_plot!
	  * support dump_code_and_data
	  * windows -> ms_windows etc
Wed Aug 30  2006  T Horinouchi
	* lib/numru/easyviz.rb: added
	* testdata/UV.jan.nc: added
Mon Aug 28  2006  T Horinouchi
	* gphys-0.5.2 released (cvs tag gphys-0_5_2)
Wed Aug 23  2006  T Horinouchi < T Koshiro [dennou-ruby:002687 & 002690]
	* ggraph.rb: Applied the patches made by T Koshiro;
	  * 002687: map-fitting (with option 'map_fit') and axes-drawing
	    (with option 'map_axes') were made available
	    simultaneously when itr=10.
	  * 002690: added axis-drwaing options: 'xmaplabel', 'ymaplabel' 
	    better axis-labelling when itr==10, with 90E, 90W, etc instead
	    of 90, 270, etc.
	  * Added examples (graph 27-30) in the test part at the bottom.
        * sample/ggraph_mapfit-axes_dr002687.rb: sample program by koshiro
	* sample/ggraph_latlon_labelling_dr002690: sample program by koshiro
Tue Aug 15  2006  T Horinouchi (ref: [dennou-ruby:002682] from koshiro)
	* sample/cira86_to_nc.rb: debug
	* attribute.rb: better error message in Attribue#[]=
Tue Aug 15  2006  T Horinouchi (ref: [dennou-ruby:002681] from nishizawa)
	* gphys.rb: GPhys#each_along_dims
	  * corrected to support NArrayMiss in addition to NArray
	  * the sencond argument is allowed to be an empy array, which 
            is a trivial case with no need for this method but
	    is supported for generality in terms of programming.
Tue Aug 15  2006  T Horinouchi
	* grid.rb: corrected the document for Grid#cut
Mon Jul 31  2006  R Mizuta
    * ggraph.rb: color_bar: support option 'chval_fmt' with using 
      option 'constwidth'. 
Wed Jun 14  2006  T Horinouchi
	* gphys.rb: replaced .is_a?(GPhys) with .respond_to?(:grid),
	  since it causes troubles in binary operations through dRuby.
Mon May 15 2006  S Nishizawa (logging forgotten; added by horinout on june 14)
	* grib_params.rb, grib.rb: new parameters added...
Fri Mar 24  2006  T Horinouchi
	* ggraph.rb: added option "no_new_fig" to GGraph::fig. (This made
	  possible to set DCL parameters that are reset by grfrm or grfig
	  such as the uspack parameters d[xy][tl])
Tue Mar  7  2006  S Takehiro < M Nakano
	* bin/gpmaxmin: USAGE Typo fixed.
	* bin/gpview: option --int bug fixed
Wed Dec 14  2005  T Horinouchi < T Koshiro
	* lib/numru/ggraph.rb: debug in the method axes [dennou-ruby:002541]
Thu Nov 17  2005  T Horinouchi
	* lib/numru/dclext_datetime_ax.rb: debug axis label direction recovery
Wed Nov  9   2005  R Mizuta
	* grads_gridded.rb: support 'byteswapped' option, 
	  become classes under NumRu module
Mon Nov  7   2005  R Mizuta
	* grads_gridded.rb, gphys_grads_io.rb: debug in reading variables 
	  with different number of vertical levels from ZDEF. 
	* grads_gridded.rb: minor modification in reading
Tue Oct  31  2005   S Takehiro
	* bin/gpview: option --smooth bug fixed.
Tue Oct  30  2005   S Takehiro
        * bin/gpview: --animate option recoverd.
Wed Oct  5  2005   T Horinouchi
	* ggraph.rb: color_bar: enhancement (& debug) of the modification on
	  Sep 27 2005 to support trn > 5
Tue Sep 27  2005   T Horinouchi
	* ggraph.rb: color_bar: to restore viewport, window, and trn at exit,
	  so that one can overlay plots after showing a color bar.
Mon Sep 26  2005   T Horinouchi
	* ggraph.rb: color_bar added option 'chval_fmt' to override the
	  internal automatic setting.
	* varray.rb: minor modification in binary operations for better
	  error messaging.
Tue Sep 13  2005   T Horinouchi
	* lib/numru/dclext_datetime_ax.rb: added (it was developed
	  separately at ~/davis/WORK/dcl/)
Tue Sep 13  2005   T Horinouchi < T Koshiro
	* grads_gridded.rb: debug in []
Mon Sep 12  2005   T Horinouchi
	* gphys_netcdf_io.rb: added a test for the axis treatment (see below)
	* axis.rb: added methods Axis#cyclic? and Axis#modulo.
        * varray.rb: added methods VArray#axis_cyclic? and VArray#axis_modulo.
	* grid.rb: 
	  * refactoring: Grid.new -> self.class.new (for inheritance)
	  * Grid#merge: avoid redunduncy in lost_axes
Fri Sep  9  2005   T Horinouchi
	* gphys-0.5.1 released (cvs tag gphys-0_5_1)
Mon Aug 29  2005   T Horinouchi
	* ggraph.rb: minor improvement when [xy]intv >= 2 (to plot at max
	  num of grid points)
Tue Aug 23  2005   S Takehiro
	* lib/numru/gphys/gpcommon.rb: 'help' method bug fix.
Tue Aug 23  2005   S Takehiro
	* bin/: gpaop craated
	* bin/gp*, lib/numru/gphys/gpcommon.rb: common methods to bin/gp* 
	  command moved to gpcommon.rb.
	* bin/gpview: multiple Gphys variables plotting and option --var 
	  implemented.
	* bin/gpcut,gpcat,gpaop,gpmath: Global attributes are copied to
	  the output ncfile when the input is NetCDF. 
Sun Aug 21  2005   S Takehiro
	* bin/: gpadd, gpsub, gpmulti, gpdiv removed.
Sun Aug 21  2005   S Takehiro
	* bin/: gpadd, gpsub, gpmulti, gpdiv created.
Tue Aug 16  2005   T Horinouchi
	* varray.rb: Added VArray#reshape.
	* axis.rb: Debug in Axis#integrate (in judgment for prodefined
	  integration weight -- it was never to use a non-default one
	  becasuse of a typo). Added Axis#integ_weigtht(=) and
	  Axis#average_weighte(=)
Tue Aug  10  2005   S Takehiro
        * bin/gpmaxmin: locations having max and min values are displayed.
          utilize internal function for printing help message.
          --all, --index, --number options added.
	* bin/gpcat, gpcut, gpmath, gpprint, gplist: utilize internal
	  function for printing help message.
Tue Aug  9  2005   T Horinouchi
	* doc/: updated
Tue Aug  9  2005   S Takehiro
	* bin/gpview: add option --help and help function < T Horinouchi,
          URL information corrected.
Tue Aug  9  2005   T Horinouchi
	* ggraph.rb: contour,tone,vector: debug in the cyclic extention
	  handling for itr==5.
	* ggraph.rb: contour,tone,vector: added option 'exchange', which
	  is a synonym for 'transpose'.
Sat Aug  7  2005   S Takehiro
	* bin/gpmaxmin: parse_gturl removed.
	* bin/gpview: option --overplot implemented.
Fri Aug  5  2005   T Horinouchi
	* grid.rb: Grid#ax_dim (protected method) changed to allow
	  negative dimension
	* install.rb: takehiro modification corrected
Wed Jul 27  2005   T Horinouchi < M Nakano
	* ggraph.rb: debug vector (to use yintv for y-axis)
Thu Jul 21  2005   T Horinouchi
 	* bin/gdir_client: RD document commented out
	* doc/index.rd: a link error corrected (gdir)
	* doc/ updated
	* lib/numru/gdir.rb: 
	  * rd document changed a bit
	  * GDir#initialize : debug in abspath setting
Wed Jul 20  2005   S Takehiro
	* recover install.rb from that for debian packaging. 
Wed Jul 15  2005   S Takehiro
        * bin/gpview: option --noannotate implemented.
	* bin/gpcut,gpmaxmin,gpmath: open_gturl method is used 
	  for opening gphys variable.
Wed Jul 13  2005   T Horinouchi
	* varray.rb: eliminate an error in binary operations when data without
	  missing is on the lefthand and data with missing is on the righthand.
Thu Jun 30  2005   T Horinouchi
	* gphys.rb : re-activated the correction disabled on June 21.
Wed Jun 23  2005   S Takehiro
	* bin/gpview: debug, option --title implemented.
Wed Jun 22  2005   T Horinouchi
	* ggraph.rb: DCLExt::color_bar : labeling improved -- to show
	  more digits if needed (for levels such as 1001,1002,1003,..).
          (It was left to the uxypak default, chval fmt 'b', which uses only 3)
Tue Jun 22  2005   S Takehiro 
	* bin/gpview: debug, clipping control added to GGraph::annotate.
Tue Jun 21  2005   T Horinouchi
	* doc/ updated.
	* <lib/numru/gdir.rb: modified to accept DODS URLs by using 
	  lib/numru/htdir.rb (see below).
	* lib/numru/htdir.rb: Created. 
	  class NumRu::GDir::HtDir : A class to treat the URL of a 
	  "directory" as a directory, with a special interpretation for DODS
	  URL if requested.
	* gphys_io.rb: GPhys::IO::file2type modified to treat URLs
	  starting with 'http://' as NetCDF, hoping that it is treated
	  as DODS extention of the NetCDF
Tue Jun 21  2005   T Horinouchi
	* bin/gplist: modfied to use GDir
	* doc/ updated
	* bin/gdir_client: RD document added.
Fri Jun 21  2005   S Takeshiro
	* bin: gpcut, gpcat, gplist, gpmath, gpmaxmin are created. 
	* doc: gpcut.html, gpcat.html, gplist.html, gpmath.html, 
	  gpmaxmin.html are created. 
	* doc/, bin/: gpcut, gpmaxmin comment fixed.
Tue Jun 21  2005   T Horinouchi
	* gphys.rb : *temporarily* disabled the modification on Jun 16:
	  >>  not to take 
	  >>    na_other = self.data.val.fill(other)
          >>  which is inefficitent. But this would require a
  	  by re-activating l.636 (be removing comment-out chars).
	  Plus, a minor debug of an enbug on Jun 16.
Fri Jun 17  2005   T Horinouchi < S Takeshiro
	* bin/gpview: debug [dennou-ruby:002321], [dennou-ruby:002328(7)]
Thu Jun 16  2005   T Horinouchi
	* gphys.rb : GPhys#coerce modified
	  * not to take 
	      na_other = self.data.val.fill(other)
            which is inefficitent. But this would require a
	    future new version of NArrayMiss (later than 1.1.1)
	  * set nil to units of a Numric/NArray for
	    correct units handling bor both add/sub and mlt/div (see below).
	* varray.rb : 
	  * Binary_operators_Uconv (+,-,add!,sbt!) : to use other's units
	    if 'units' attribute is emtpy (nil), rather than interpreting
	    it as '1' (non-dimension).
	  * collect a typo: sub!(which is non-exitent in NArray) --> sbt!
	* grid.rb : added Grid#merge
Wed Jun 15  2005   T Horinouchi < S Takeshiro
	* bin/gpprint: debug [dennou-ruby:002321]
Mon Jun  6  2005   T Horinouchi < S Otsuka
	* gphys_netcdf_io.rb: modified the edition of NetCDF_IO::open just 
	  before.
Mon Jun  6  2005   T Horinouchi
	* gphys-0.5.0 released (cvs tag gphys-0_5_0)
	* doc/: updated
Mon Jun  6  2005   T Horinouchi
	* gdir_connect_ftp-like.rb: very minor change in URL handling
	  (chomp -> strip)
	* bin/gdir_server: changed the default behavior to allow
	  connections only from the localhost. (You need specify
	  -a hoge.hero.org or -a all etc. to accept remote hosts.)
Mon Jun  6  2005   T Horinouchi < S Otsuka
	* gphys_netcdf_io.rb: NetCDF_IO::open : improved handling of
	  files without coordinate variables. (add "_#{dim}" to 
	  the automatically generated name "noname")
Mon Jun  6  2005   T Horinouchi
	* gphys_io_common.rb: IO_Common::each_along_dims_write : changed to
	  use the new grid obtained with *_IO::write_grid
          [It solves the problem reported by T Koshiro
          (Subject: GPhys::NetCDF_IO.each_along_dims_write
          Date: Wed, 27 Apr 2005 11:00:40 +0900)]
	* gphys_netcdf_io.rb: GPhys::NetCDF_IO::write_grid : changed
	  to return a Grid object, in which all VArrays in the original
	  grid are replaced with the new ones in the file (the return
	  value used to be nil).
	* axis.rb: added methods Axis#each_varray, Axis#collect.
Mon May 30  2005   T Horinouchi (thanks to T Koshiro)
	* ggraph.rb: GGraph#(tone|contour|vector): debug in 
	  cyclic extension treatment; GGraph#map_trn?: modified
	  to support the debug in tone etc.
Wed May 25  2005   T Horinouchi
	* grads_gridded.rb: GrADS_Gridded#parse_ctl: to use a bit simpler
	  time representation
	* grads_gridded.rb: GrADS_Gridded#parse_starttime:
	  changed to accept lower-case "z" (which is leagal).
	* grads_gridded.rb: GrADSVar#initialize: added attribute 
	  'missing_value', which is 'undef' in GrADS_Gridded.
	* grads_gridded.rb: GrADS_Gridded#parse_ctl: change in the
	  relative path intepretation: to deal with path without
	  '^' at the beginning (BEFORE: '^hoge' -> absolute path,
	  'hoge' -> remained relative; AFTER: both -> absolute path.
	  So you don't need to be at the data directory anymore.)
Tue May 24  2005   T Horinouchi
	* grads_gridded.rb: GrADS_Gridded#get_dim: to use float for
 	  spacial dimensions as well as time.
	  GrADSVar#vartype: to return 'float' for coordinate variables.
	* grads_gridded.rb: GrADSVar#initialize: to raise error if the 
	  variable name specified (varname) is not found in the ctl file.
Fri May 13  2005   T Horinouchi
	* ggraph.rb: Added method GGraph::tone_and_contour.
	  (requires numru-misc-0.0.6 or later)
	* bin/gdir_server: added option to explicitly specify host address
	* gdir.rb: sort gdirs and texts in list_*; plus, a very minor change
	* gdir_connect_ftp-like.rb: start_dcl: to call 
	  DCL.swpset('lwait',false) (if you don't like it, you don't need to
	  use start_dcl.)
Wed May 11  2005   T Horinouchi
	* Merged gphys-remote-0.4 in gphys:
	  * commands bin/gdir_server and bin/gdir_client
	    (the former was renamed from gdir_server.rb in gphys-remote).
	  * irb start-up file lib/numru/gdir_connect_ftp-like.rb
            (renamed from gphys_connect_ftp-like.rb in gphys-remote).
Tue May 10  2005   T Horinouchi
	* ggraph.rb: GGraph's visualization methods are changed to call
	  DCL.gropn(1) if gropn/sgopn has not been called
	  (by introducing GGraph::gropn_1_if_not_yet).
	* gdir.rb: Added GDir.pwd, GDir#each_dir, GDir#each_data.
          show, show_v are reorganized and renamed to list_all,
	  list_all_v, which returns the result as strings.
	  ls / ls_l now prints their results.
Mon May  9  2005   T Horinouchi
	* subsetmapping.rb: SubsetMapping1D.new: support reversed range.
	* varray.rb: VArray#val: interpret Hash slicers for NArray/NArrayMiss
	* ggraph.rb: 
	  GGraph::map: added option 'fill'.
	  GGraph::contour / GGraph::tone: when map projection, convert to
	  the anti-clockwise coordinate to get around a bug in UMFMAP in
	  DCL 5.3
Fri May  6  2005   T Horinouchi < T Koshiro
	* ggraph.rb: GGraph::map added options "dgridmj" and "dgridmn"
Wed Apr 27  2005   T Horinouchi
	* ggraph.rb: separated annotate_at from annotate
Fri Apr 15  2005   T Horinouchi
	* ggraph.rb: Further modification for map projection:
	  The strategy of the previous edition was not good.
	  If map is to be drawn, 'itr' should be 10 and axes should be drawn
	  afterwards. Eliminated the new "map" and introduced "map_axes".
Fri Apr 15  2005   T Horinouchi
	* lib/numru/gdir.rb: added GDir#open_all_data. Renamed ls_v ->
	  ls_l, which I originally meant. Supported path in show, show_v.
	  Support the path argument in show and show_v
	* gphys_io.rb: corrrected a spell miss of method name in documentation
	* ggraph.rb: Revision regarding map projection:
	  * GGraph::fig: Option changed from map_lat_range -> map_window
	    (the latter includes log-lat range, and the former is eliminated).
	    Added new option 'map_fit', which is for itr=10 and 11.
	    Changed the default behavior for itr=10 (cylindrical) to fit
            the map to the data window (equiv to 'map_fit'=>true). 
	    Concequently, the default window for itr=10 is now the same as 
	    with itr=1.
	  * GGraph::tone & GGraph::contour: added option 'map_fit', 
	    which draws map etc by switching temporarilly to itr=10 and
	    calling GGraph::map.
	* sample/map_projection.rb: Revised according to the change 
	  of ggraph.rb. New samples were added regarding the 'map_fit'
	  option of fig and the 'map' option of tone/contour.
	* doc/: updated
Wed Apr 13  2005   T Horinouchi
	* lib/numru/gdir.rb: Imported (moved) from gphys-remote-0.3. It will be
	  maintained here.
	* lib/numru/gphys.rb: to include gdir
	* gphys_io.rb: added method file2file_class(file), which returns
	  NetCDF, GrADS_Gridded, or Grib.
	* doc/: updated corresponding to the import of gdir.rb
Mon Apr  4  2005   S Nishizawa
	* grib.rb, grib_params.rb: change not to set attribute of "units" when variables have no unit.
Fri Apr  1  2005   T Horinouchi
        * gphys_netcdf_io.rb: added a test regarging packed data.
	* Revised netcdf convension handling. This improves attribute 
	  handling of the user's guide convention (the default one)
	  regarding data missing etc.
	  * attributenetcdf.rb: AttributeNetCDF#initialize to extend
	    Attribute_Mixin whose default is defined in netcdf_convention.rb
	  * netcdf_convention.rb: created module Attribute_Mixin
	    in NetCDF_Convention_Users_Guide. Moved contents of 
	    VArray_Mixin to Attribute_NetCDF, which is to move
	    attribute editor on copying (deep-cloning) from VArrayNetCDF
	    to AttributeNetCDF (which is used in VArrayNetCDF).
	* grads_gridded.rb: minor revision of documentation.
	  allowed modes: "r" & "w+" --> "r" & "w" (read only / write only).
	* doc/: updated
Thu Mar 31  2005   S Nishizawa
	* grib.rb: remove @define_mode and Grib#enddef
	           change value by units to write
	* varraygrib.rb: change as removing Grib#enddef
	* gphys_grib_io.rb: small change in test
Thu Mar 31  2005   T Horinouchi
	* grib.rb: Grib: eliminated @mode and introduced @define_mode
	  (It is a half-hearted job, since no @define_mode check is
	  introduced in the write method)
Thu Mar 31  2005   T Horinouchi
	* grib.rb: minor update of Grib#initialize (to refuse "w+"; 
	  corresponding error message at l.1268; documentation of file mode).
Wed Mar 30  2005   R Mizuta
	* gphys_grads_io.rb, varraygrads.rb: 
	  output normal gphys into GrADS file
Wed May 30  2005   S Nishizawa
	* grib.rb: bugfix in opening file for write
	* gphys_grib_io.rb: add test for writing, change variable name in test
	* varraygrib.rb: change variable name in test
Wed Mar 30  2005   R Mizuta
	* grads_gridded.rb: 
	  * speed up in reading
	  * GrADSVar followed changes of NetCDFVar
	* grads_gridded.rb, varraygrads.rb: 
	  gives more readable control file in GrADS output
	* gphys_grads_io.rb: bug in the test code fixed
Tue Mar 29  2005   T Horincouhi
	* gphys_io.rb: Added methods parse_gturl and open_gturl
	  (the former was moved from bin/gpprint to gphys_io.rb).
	* bin/gpprint,bin/gpview: modified to use GPhys::IO.open_gturl
        * doc/: updated
Tue Mar 29  2005   S Nishizawa
	* grib.rb: change status
Tue Mar 29  2005   T Horincouhi
	* bin/grads2nc_with_gphys: debug (repoted by S Nishizawa 2005/03/15)
        * axis.rb: document written. Changed return value of set_aux to self.
        * grid.rb: document written.
	* gphys.rb: minor updates of the document.
        * doc/: updated
Tue Mar 29  2005   S Nishizawa
	* grib.rb: remove space from attribute key names
Tue Mar 29  2005   S Nishizawa
	* grib.rb: add attribute of "level" and "time" when number of level and time is one
Tue Mar 29  2005   S Nishizawa
	* grib.rb: bugfix when number of bit for packing is odd
Tue Mar 29  2005   T Horincouhi
	* gphys_io.rb: RD document written
	* gphys.rb: 
	  * Added a class method GPhys.each_along_dims, along with its test. 
	  * Changed return value of replace_val, set_att, and del_att to self.
        * doc/: updated
Mon Mar 29  2005   S Nishizawa
	* grib.rb, grib_params.rb: add some new definitions of variables and levels for NCEP grib file.
Mon Mar 28  2005   T Horincouhi
	* grib.rb: debug to open grib files in the binary mode.
	* gphys_netcdf_io.rb: debug in is_a_NetCDF?: to open with
	  the binary mode.
Sat Mar  26   2005   R Mizuta
	* grads_gridded.rb: open binary file with binary mode
Fri Mar  25   2005   T Horinouchi
	* attribute.rb: attribute name is limited to those that matche
	  /^[A-Za-z_]\w*$/. Removed Numeric from allowed value type
	  list: Use a 1-element NArray instead.
Fri Mar  25   2005   S Nishizawa
        * grib.rb: change ' ' to '_' in name of attribute
	           change value to NArray with rank of 1 for value of attribute
Fri Mar  25   2005   S Nishizawa
        * grib.rb: enable Grib#[] to get negative value
	* gphyx_grib_io.rb: add name and atts to aux for hybrid level
Fri Mar  25   2005   S Nishizawa
	* grib.rb: change value of hybrid level
	           bugfix
	* gphys_grib_io.rb: use Axis#set_aux for hybrid level
Mon Mar  21   2005   S Nishizawa
	* grib.rb: bugfix for hybrid level
Mon Mar  21   2005   S Nishizawa
	* grib.rb: bugfix in Grib.write
	* grib_params.rb: add variable of unknown
Mon Mar  21   2005   S Nishizawa
	* grib.rb: change value of hybrid level from level number to coordinate parameters.
Mon Mar 21  2005   T Horinouchi
	* gphys_io.rb: IO::fil2type: added case when Grib.
	* gphys_grib_io.rb: Grib_IO::write: added the 3rd argument
	  as name_dummy=nil, which is a dummy and is never used but
	  is present for consistency with other *_IO modules.
Wed Mar  16  2005   T Horinouchi
	* doc/ updated.
Wed Mar  16  2005   T Horinouchi
	* gphys-0.4.0 released (cvs tag gphys-0_4_0)
	* ggraph.rb: color_bar: changed not to draw a colobar when
	  the # of levels is less or equal to 1 (warning is made
	  in this case).
Fri Mar  11   2005   D Tsukahara
	* ggraph.rb: minor bugfix 
Thu Mar  10   2005   D Tsukahara
	* ggraph.rb: minor bugfix for (Wed Mar 09   2005   D Tsukahara)
Thu Mar  10   2005   S Nishizawa
	* grib.rb: change way to make variables of longitude and latitude.
	* gphys_grib_io.rb: change to set bare_index true at hybrid level
Thu Mar  10   2005   S Nishizawa
	* grib.rb, grib_params.rb: add standard_name attribution to variables
Thu Mar  10   2005   S Nishizawa
	* grib_params.rb: change name of variable to the same name of wgrib if it possible.
	* grib.rb: minor bugfix
Thu Mar  10   2005   S Nishizawa
	* T.jan.grib: sample grib file converted from T.jan.nc
	* grib.rb, gphys_grib_io.rb: change to use T.jan.grib in sample	code, change name from is_aGrib? to is_a_Grib?
	* gphys_netcdf_io.rb, gphys_grads_io.rb, gphys_grib_io.rb, grib.rb: bugfix for is_a_*?
Thu Mar  10   2005   T Horinouchi
	* axis.rb,varray.rb: to deal with axis plot direction
	  specification:
	  axis.rb: added new method Axis#draw_positive, which simply calls
	  @pos.axis_draw_positive (see below).
	  varray.rb: added new method VArray#axis_draw_positive, which
 	  returns true (positive=='up'), false (positive=='down'), or
	  nil (undefined) --- this is based on a widely-used NetCDF
	  convention, so redefine it in VArray's subclasses if not
	  appropriate
Thu Mar  10   2005   T Horinouchi
	* netcdf_convention.rb: 
	  * in private method _op_attr_edit (called when operations are made)
	    in NetCDF_Convention_Users_Guide:
	    * Added deletion of _FillValue. 
	    * To unpack valid_* and missing_value if appropriate
 	      (in a separate new private method _unpack_missing_specification)
        * testdata/T.jan.packed.withmiss.nc: Added for test
	  (requires RubyNetCDF 0.6.0, since missing_value is in 
	  the packed data type.)
Wed Mar 09   2005   D Tsukahara
	* ggraph.rb: fix fig (option "window" can have its element "nil"),
	  line and mark (add option "max", "min")
	* bin/gpview: apply option "range" for line plot
	* doc/ep_flux/index*: change link for tutorial page
Tue Mar 07   2005   T Horinouchi < T Koshiro
	* ggraph.rb: [dennou-ruby:002075] support auto-level setting when
	  level is explicitly given.
Tue Mar 07   2005   S Nishizawa
        * gphys_IO.rb gphys_netcdf_io.rb gphys_grads_io.rb gphys_grib_io.rb:
          add class methods; var_names, var_names_except_coordinates, is_a_[NetCDF,GrADS,Grib]?, respectively, except gphys_io.rb
	  add part using is_a_*? methods to distinction of file type
Thu Mar 03   2005   D Tsukahara
	* doc/derivative/math-doc/*: fix and amend a text
Tue Mar 02   2005   S Nishizawa
	* grib.rb, varraygrib.rb, gphys_grib_io.rb: support writing
Tue Feb 26   2005   S Nishizawa
	* grib.rb: remove dimension variables from variables
	  change timing to obtain variable infomation from Grib.open to Grib#var
	  add methods GribDim#get, GribDim#[], GribDim#[set,put]_att, DribDim#att
	* varraygrib.rb, gphys_grib_io.rb: some changes corresponding to the changes of grib.rb
Tue Feb 25   2005   S Nishizawa
	* grib.rb: support missing value
	* varraygrib.rb: change path of grib.rb
Tue Feb 25   2005   S Nishizawa
	* grib.rb: change to use NArray.to_na
	  some changes to speed up
Tue Feb 24   2005   S Nishizawa
	* grib.rb: separate definition of parameters to grib_params.rb
	* grib_params.rb: imported (from separated from grib.rb and added some new definitions for ECMWF datasets)
Tue Feb 22   2005   S Nishizawa  (cvs committed by Horinouchi)
	* grib.rb,varraygrib.rb,gphys_grib_io.rb: imported. 
	  (Grib data handlers.)
Thu Feb 19   2005   D Tsukahara
	* doc/ep_flux/math-doc/*: fix and amend a text(Thanks to M Ishiwatari)
Thu Feb 16   2005   D Tsukahara
	* ep_flux.rb: fix EP_Flux::strm_rmean( change integrate method ),
	  delete EP_Flux::prepare_for_divergence_on_merdional_section.
	* test/test_ep_flux.rb: add test for strm_rmean( looks succesfully )
	* doc/ep_flux/ep_flux.html: regenerated
Thu Feb 10   2005   D Tsukahara
        * bin/gpview: add option --map, --m, --reverse, -Gr.
	  change option parser (getopts => getoptlong) because
	  getopts would be obsolute.
	* doc/gpview.html: regenerated.
Thu Feb 3   2005   T Horinouchi
	* gphys_io_common.rb: IO_common::each_along_dims_write: modified
	  to accept GPhys'es that do not have the same shape ---
	  It's now ok as long as the dimensions to loop are shared.
	* gphys_netcdf_io.rb: Added a test for the new feature of
	  each_long_dims_write. Plus, documentation updated.
	* doc/gphys_netcdf_io.html: regenerated.
Thu Feb 3   2005   T Horinouchi
	* gphys_io_common.rb: IO_common::each_along_dims_write: modified
	  to accept GPhys'es that do not have the same shape ---
	  It's now ok as long as the dimensions to loop are shared.
	* gphys_netcdf_io.rb: Added a test for the new feature of
	  each_long_dims_write. Plus, documentation updated.
	* doc/gphys_netcdf_io.html: regenerated.
Wed Feb 02  2005   D Tsukahara < M Nakano
	* bin/gpview: debug about looopsense_flag(each_along_dims)
Wed Jan 26  2005   S Takehiro
	* options --map_axis and --similar are added to gpview. 
Tue Jan 25  2005   T Horinouchi < S Takehiro
	* numru/ggraph.rb: support tranformation number 5 (polar
	  coorodnate) by S Takeshiro (with a modification by Horinouchi).
	  Added: GGraph::polar_coordinate_boundaries
	         GGraph::sim_trn? (currently not used)
          Modified: GGraph::fig, GGraph::contour, GGraph::tone
Tue Jan 25  2005   T Horinouchi
	* gphys.rb: GPhys#cyclic_ext debug
Thu Jan 20  2005   T Horinouchi < T Koshiro
	* numru/ggraph.rb: DCLExt::color_bar -- always lclip=false in
	  the method.
Mon Jan 17  2005   T Horinouchi
	* numru/ggraph.rb: added contour test under map projection
	* gphys.rb: debug in GPhys::cyclic_ext
	* varray.rb,gphys.rb: Added methods VArray#long_name,
          VArray#long_name=, GPhys#long_name, GPhys#long_name=.
Fri Jan 14  2005   T Horinouchi
	* gphys-0.3.5 released (cvs tag gphys-0_3_5)
Fri Jan 14  2005   T Horinouchi
	* bin/gpview: l.202 'itr'=>($OPT_itr) --> 'itr'=>($OPT_itr.to_i)
	  --mean and --animate are changed to accpet integers as well as 
	  dimension names.
Fri Jan 14  2005   D Tsukahara
	* bin/gpview: delete --map, -m(don't redef GGraph's method) 
Fri Jan 14  2005   R Mizuta
	* numru/gphys/grads_gridded.rb: disuse Date.parse (for Ruby 1.6)
Fri Jan 14  2005   T Horinouchi < S Takehiro
	* install.rb: editied help messaging
Thu Jan 13  2005   T Horinouchi
	* numru/ggraph.rb: DCLExt::color_bar: bug fix in the calculation
	  of offs_(tick|label) under the uniform tone level interval
	  (independent of Mizuta-kun's revision).
	  Added 3 sample graphics for map projection (graph 22-24).
	  Added contour to graph 11.
	* doc/ggraph.html: regenerated
Thu Jan 13  2005   R Mizuta
	* numru/ggraph.rb: DCLExt::color_bar: added options (constwidth,index). 
Wed Jan 12  2005   T Horinouchi
	* numru/ggraph.rb: Support map projection: 
	  new methods: map, set_map, next_map, map_trn?
	  modified methods: fig, title, annotate, contour, tone, vector
	* numru/ggraph.rb: documents updated.
	* grid.rb: set_axis: modified to return self.
	* gphys.rb: added new method cyclic_ext.
	* varray.rb: [], []=: modified to accept false (rubber dim)
	  Unbelievable that it was not yet.
	* sample/map_projection.rb: created. (sample program to demonstrate
 	  map projection with GGraph)
        * doc/gpprint.html,doc/gpview.html,doc/grads2nc_with_gphys.html: 
	  created using rd2.
	* doc/index.(rd|html): modified to include the commands.
Mon Jan 12  2005   D Tsukahara
	* bin/gpview: use GGraph::margin_info and GGraph::color_bar. Add many
	  options(ex. s/cint, s/crange, aspect...), write options document,
	  and fix SAMPLE.
Mon Jan 10  2005   T Horinouchi (partly < D Tsukahara)
	* install.rb: changed to install files in bin/
	* bin/install.rb: removed
	* bin/grads2nc_with_gphys: renamed grads2nc.rb to grads2nc_with_gphys
	* bin/gpprint: added
	* bin/gpview: added -- This program was written by D Tsukahara
	  and imported from [dennou-ruby:001970]
Mon Jan 10  2005   T Horinouchi
        * numru/ggraph.rb: Added GGraph::margin_info, which shows
	  strings in the bottom margin (representing program name, date, 
	  and data source)
	* numru/ggraph.rb: DCLExt::color_bar: improved the algorithm used 
	  to define levels to label.
Tue Dec  7  2004   T Horinouchi
        * numru/ggraph.rb: DCLExt::color_bar: changed the default to portrait
	  (which looks nicer). Labelling is improved to chose good levels.
Mon Dec  6  2004   T Horinouchi
	* grid.rb: Grid#transpose modified to preserve @lost_axes
Fri Dec  3  2004   T Horinouchi
	* varray.rb: VArray#coerse: added NArrayMiss support
Wed Dec  1  2004   T Horinouchi
	* numru/ggraph.rb: 
	  * GGraph::tone: changed the default value of 'tonc'
	    and 'tonf' to false. (there seems a bug in uetonf, while a bug in
	    uetone must have eliminated in dcl5.3. Also, I think it was my
	    careless mistake to set the default val of 'tonc' to true.)
	    Changed the timing to call DCL.ueitlv -- this is to leave
	    tone levels for color bars.
          * DCLExt::color_bar: Created. General program to draw COLOR BARS.
Mon Nov 29  2004   R Mizuta
	* numru/gphys/grads_gridded.rb: changed the basis of time axis 
	  from the first Julian period to the date of the first data record. 
Wed Nov 24  2004   R Mizuta
	* numru/gphys/grads_gridded.rb: support data containing missing data, 
	  2-byte signed integers, and 1-byte unsigned integers. 
Tue Nov 12  2004   D Tsukahara
	* numru/gphys/ep_flux.rb: 
	  1. add accesor method p00 and modified set||get constants
	  2. undef C_p and R; instead def @@cp, @@gas_const and accesor method.
	  3. fix document: ep_full_sphere(about argument xfzdims)
	* test/test_ep_flux.rb: reflect adjustment of ep_flux.rb
Tue Nov 09  2004   T Horinouchi
	* gphys-0.3.4 released (cvs tag gphys-0_3_4)
	* varray.rb: coerce: changed the assumptions of the units of
	  Numeric etc (to assume the same units instead of non-dim, for
	  consistency between numeric+varray and varray+numeric).
	  Refactoring regarding attribute copying.
Mon Nov 08  2004   T Horinouchi
	* numru/gphys.rb: to require numru/gphys/ep_flux
	  (which requires numru/gphys/derivative etc)
Mon Nov 08  2004   D Tsukahara
	* numru/gphys/ep_flux.rb: modified
	  1. add accesor method g_forces
	  2. delete "require numru/gphys"
	  3. fixed strm_rmean : change int_v (VArray => GPhys) and not setting
	     units.
	* sample/ep_flux/demo_NCEP_1.rb,demo_NCEP_2.rb,demo_NCEP_3.rb:
	  write testdata's URL and simple description.
Tue Nov 02  2004   D Tsukahara
	* doc/ep_flux.rd,ep_flux.html: fixed dead link and updated for Tutrial.
	* numru/ggraph_on_merdional_section.rb:
	  delete GGraph::divergence_on_merdional_section
	* doc/ep_flux/ggraph_on_merdional_section.html:
	  delete GGraph::divergence_on_merdional_section
Thu Nov 02  2004   T Horinouchi
	* doc/index.(rd|html)  updated for ep_flux and derivative.
Tue Nov 02  2004   D Tsukahara
	* numru/gphys/ep_flux.rb: created
	* numru/ggraph_on_merdional_section.rb: created
	* TODO_ep_flux: created
	* numru/derivative.rb: created
	* numru/gphys/derivative.rb: created
	* test/test_ep_flux.rb:created
	* sample/ep_flux/demo_NCEP_1.rb,demo_NCEP_2.rb,demo_NCEP_3.rb: created
	  (require demo-data)
	* doc/ep_flux/index.rd,index.html,ep_flux.html,
	  ggraph_on_merdional_section.html: created
	* doc/ep_flux/math-doc/document.tex,document.pdf: created
	* doc/ep_flux/math-doc/document/*: many mathmatical document files
	  created (html version)
	* doc/derivative/index.rd,index.html,numru-derivative.html,
	  gphys-derivative.html: created
	* doc/derivative/math-doc/document.tex,document.pdf: created
	* doc/derivative/math-doc/document/*: many mathmatical document files
	  created (html version)
Thu Aug 26  2004   T Horinouchi
	* gphys_io_common.rb: debug in each_along_dims_write
Fri Aug 18  2004   T Horinouchi
	* ggraph.rb: Added options 'tonf', 'tonc' to GGraph.tone
Fri Aug 12  2004   T Horinouchi
        * ggraph.rb: Added GGraph::vector. Renamed DCLExt::ug_flow_vect
	  to DCLExt::flow_vect and revised. Added DCLExt::unit_vect;
	  DCLExt::set_unit_vect_options, and DCLExt::next_unit_vect_options.
	* gphys.rb: added att_names, get_att, set_att,
	  put_att(aliased to set_att), del_att.
	* varray.rb: added VArray#attr_copy
	* netcdf_convention.rb: _op_attr_edit: not to delete 'long_name'
Fri Aug 10  2004   T Horinouchi
	* varray.rb,gphys.rb: added method convert_units
Fri Aug  9  2004   T Horinouchi
        * ggraph.rb: added DCLExt::ug_flow_vect
	* removed ggraph_old.rb (to be deleted in the next release)
Fri Aug  9  2004   T Horinouchi
	* gphys-0.3.3 released (cvs tag gphys-0_3_3)
	* grid.rb: delete_axes: to allow dimension specification by name(s)
	* axis.rb(,gphys.rb): added Axis#to_gphys(datavary1d=nil), which
	  makes a 1D GPhys object using the axis. By default, the axis's
	  coordinate variable is used as the data.
	  Its test program was added to gphys.rb.
	* ggraph.rb: contour,tone: added transpose option to exchange x&y axes.
        * grid.rb,varray.rb,gphys.rb: added transpose method.
	* varray.rb: added VArray#del_att. VArray#coerce: support UNumeric.
          asin, atan etc: units of the return value set to 'rad' (it was '1')
	* unumeric.rb: debug in expection messaging in UNumeric#convert2
          Math funcs such as log&sin: to return UNumeric (instead of Numeric).
          Added atan2.
          asin, atan etc: units of the return value set to 'rad' (it was '1')
Fri Jul 16  2004   T Horinouchi
	* ggraph.rb: 
	  axes -- to set the uz parameter 'roffxt', when units of the left
	  y axis is to be written to avoid the overlay with the title.
	  line -- added a new parameter 'label'
Thu Jul 15  2004   T Horinouchi
	* gphys_fft.rb: added GPhys#detrend, GPhys#cos_taper, 
	  and GPhys::COS_TAPER_SP_FACTOR (==1/0.875)
Thu Jul 15  2004   R Mizuta
	* grads_gridded.rb: created natts, get_att, and att_names
Thu Jun 10  2004   T Horinouchi
	* grads_gridded.rb: treat cray_32bit_ieee as bigendian
Thu May 24  2004   R Mizuta
	* coordtransform.rb: bug fixed
Fri May 21  2004   T Horinouchi
	* gphys-0.3.2 released (cvs tag gphys-0_3_2)
	* gphys_io_common.rb: debug in each_along_dims_write -- the previous
	  version did not work with the unlimited dimension.
	* coordtransform.rb: minor change (HAVE_SSL2 -> HAVE_NUMRU_SSL2)
Mon May 10  2004   R Mizuta
	* grads_gridded.rb,gphys_grads_io.rb,varraygrads.rb: 
	  supported GrADS output
	* coordtransform.rb: linear interpolation without SSL2
Wed May  5  2004   T Horinouchi
	* gphys.rb: [],[]=: minor debug (handling of specification by dim name)
	* ggraph.rb: _set_tone_levels_ (used in tone): improved --
	  it is ok now not to specify 'patterns'.
	  tone: added options 'clr_min', 'clr_max' (just for convenience
	  and consitstency with contour --- one can instead directly
	  specify the uepack parameter icolor[12])
Tue May  4  2004   T Horinouchi
	* gphys_fft.rb: debug & improve coordinate handling in GPhys#fft
Sun May  2  2004   T Horinouchi
	* gphys_fft.rb: added units handling in rawspect2powerspect
	* unumeric.rb: debug in "/"; added the "**"
Fri Apr  2  2004   T Horinouchi
	* netcdf_convention.rb: NetCDF_Conventions::find -> not to raise an
	  exception when gtool4
Sun Mar 21  2004   T Horinouchi
	* gphys-0.3.1 released (cvs tag gphys-0_3_1)
	* ggraph.rb,gphys.rb: Moved GPhys#first1D & GPhys#first1D from the
	  former to the latter.
        * gphys_io.rb: very minor change
Sat Mar 20  2004   T Horinouchi
	* grads_gridded.rb: GrADS_Gridded: added reader to @ctlfile
	* lib/numru/gphys.rb: changed required files accordingly	
	* gphys_io.rb: Created (module GPhys::IO). 
	  Consolidates specific IO modules such as GrADS_IO and NetCDF_IO.
	  Figures out file type internally and forward messages to
	  appropriate modules.
	* gphys_io_common.rb: Created by separating from
	  gphys_netcdf_io.rb. Internal usage only (to be used by IO,
	  NetCDF_IO, GrADS_IO etc.)
	* gphys_netcdf_io.rb: Separated module IO_Common into 
	  gphys_io_common.rb.
Fri Mar 19  2004   T Horinouchi
	* ggraph.rb: Do not check class of a VArray (for dRuby)
	* varray.rb: NMath --> Misc::EMath, debug: VArray#** (units treatment)
	* unumeric.rb: scale-offset conversion --> to warn regardress $VERBOSE
Thu Mar  4  2004   T Horinouchi
	* varray.rb: __ntype: "lint" -> "int"
Tue Mar  2  2004   T Horinouchi
	* netcdf_convention.rb: minor debug in an exception message
Tue Mar  2  2004   T Horinouchi
	* gphys-0.3.0 released (cvs tag gphys-0_3_0)
	* doc/index.rd: created (separated from lib/numru/gphys.rb)
	* netcdf_convention.rb: CREATED. To hold NetCDF convensions
	  --- better support of the User's Guide convention.
	  Supported the Wind Profiler convention.
	* unumeric.rb: added documentation.
	* gphys_netcdf_io.rb,varraynetcdf.rb,varraycomposite.rb: changed
	  according to the introduction of netcdf_convention.rb
	* varray.rb,gphys.rb: supported atan2
	* attributenetcdf.rb: AttributeNetCDF.new: to accept a NetCDF in
	  addition to NetCDFVar (this is to support global attributes).
Mon Mar  1  2004   T Horinouchi
	* varraycomposite.rb: val: to support NArraMiss; added convention
	* varraynetcdf.rb: convention module moved in from gphys_netcdf_io.rb.
	  NetCDFVar#get/put re-aliasesed to (get|put)_with_miss_and_scaling
          (by default, they are aliased to simple_(get|put)).
	  (CAUTION: Need NArrayMiss newer THAN 1.0.1, which has a bug)
	* gphys_netcdf_io.rb: convention module moved out to varraynetcdf.rb
Sun Feb 29  2004   T Horinouchi
	* unumeric.rb: added to_f, to_i
Sat Feb 28  2004   T Horinouchi
	* gphys_fft.rb: change to use a NumRu::Units operation in wavenum calc
Fri Feb 27  2004   T Horinouchi
	* unumeric.rb: created.
	* varray.rb: Modified to use NumRu::Units
	  - added methods units and units=
	  - modified Math funcs, binary operators, and
	    type3_methods (mean,max,etc).
	* gphys.rb: added methods units and units= (forwarded to @data)
	* axis.rb,grid.rb: minor change in response to the change in varray.rb
Fri Feb 27  2004   T Horinouchi
	* varray.rb: improved binary operators (to coerce unknown objects).
	  VArray#coerce: debug.
	  VArray#val: changed to return @ary.dup instead of @ary for
	  consistency with other VArray subclasses and the mapping case.
	* gphys.rb: added GPhys#coerce, 
	  binary&math operators: changed to copy the grid
Thu Feb  5  2004   T Horinouchi
	* gphys_fft.rb: Debuged spect_zero_centering and spect_one_sided.
	  Made a test part. Added rawspect2powerspect.
Wed Feb  4  2004   T Horinouchi
	* varray.rb: increased NArray_type1_methods (such as real, imag,
	  random, etc.etc.) and Binary_operators (imag=).
	* gphys_fft.rb: added new GPhys methods spect_zero_centering
	  and spect_one_sided.
Thu Jan 29  2004  T Horinouchi < S Nishizawa
	* gphys_netcdf_io.rb: debug in NetCDF_IO::open
Thu Jan 29  2004  T Horinouchi
	* gphys-0.2.3 released
	* axis.rb: Axis#cut/Axis#cut_rank_conserving:
 	  supported multiple position specification by Array/NArray
	* gphys.rb: added a test for GPhys#cut (which depends on Axis#cut)
	* varray.rb,gphys.rb: removed spaces before parentheses.
Tue Jan 27  2004  T Horinouchi
	* varraycomposite.rb: redefined methods ntype and typecode
Tue Jan  6  2004  T Horinouchi
	* gphys_netcdf_io.rb: created GPhys::IO_Common module, which is to 
	  be separated in a independent file in future. 
	  Made IO_Common::each_along_dims_write and 
	  NetCDF_IO::each_along_dims_write, where the latter uses the former.
	* axis.rb: debug in Axis#[] (treatment of @aux)
	* gphys.rb: added GPhys#rename
Mon Jan  5  2004  T Horinouchi
	* varraynetcdf.rb: aliased VArrayNetCDF.new2 to VArrayNetCDF.def_var
	* gphys.rb: created GPhys#dim_index.
	  GPhys#[], GPhys#[]= : enhanced to support specification by Hash
	  (with keys representing axis names. e.g., gphys['x'=>2..-3]).
Sun Jan  4  2004  T Horinouchi
	* grid.rb: unify Grid#axis and Grid#get_axis (so, get_axis
	  is kept only for backward compatibility)
	* gphys.rb: replaced Grid#get_axis calls with Grid#axis calls.
	  Created GPhys#grid_copy to return a deep clone of the grid 
	  (@grid.copy).
	* gphys_netcdf_io.rb: separated NetCDF_IO::write_grid from 
	  NetCDF_IO::write
	* varraynetcdf.rb: VArrayNetCDF.new2 (class method): to allow
	  dimension specification by name.
Thu Nov 20  2003  T Horinouchi
	* gphys_fft.rb: to use FFTW3 if exists
Mon Nov 17  2003  T Horinouchi
	* lib/numru/gphys.rb: to require gphys_operations
	* gphys_fft.rb: created
	* varray.rb: VArray#name modified to return a copy (dup) of the name
	* varray.rb: added "abs" to NArray_type1_methods
	* varray.rb: added a new method VArray#replace_val
	* gphys.rb: added a new method GPhys#replace_val
Mon Nov 10  2003  R Mizuta
        * ggraph.rb: debug in tone, options added to axes, and
          support of String in xx_set_params
Sun Nov  9  2003  T Horinouchi
	* gphys_netcdf_io.rb: debug in __to_na_of_netcdf.
Fri Nov  7  2003  T Horinouchi
	* gphys-0.2.2 released
	* bin/grads2nc.rb: created. (file format converter)
	* bin/install.rb: created. (to install files in bin/)
	* lib/numru/gphys.rb: to require "gphys_grads_io.rb"
	* gphys_grads_io.rb: added an RD document
Wed Nov  5  2003  T Horinouchi
	* varray.rb: added to_i, to_f and to_type to NArray_type1_methods
Tue Oct 28  2003  R Mizuta
	* grads_gridded.rb: bugs fixed and ruby-1.8 support
	* gphys_grads_io.rb: transforms GrADS into NetCDF in the test code.
Tue Oct 28  2003  T Horinouchi
	* varraynetcf.rb: VArrayNetCDF#write: debug unlim-dim treatment etc.
	  VArrayNetCDF#val=: improved unlimited dim treatment.
Fri Oct 24  2003  T Horinouchi
	* gphys.rb: enhanced GPhys#mean etc (VArray::NArray_type3_methods)
	  to accept specification by name
	* grid.rb: changed Grid#axnames and Grid#lost_axes to duplicate
	  the resultant array to return.
Thu Oct 23  2003  T Horinouchi
	* gphys.rb: debug - Binary operators, GPhys#shape_coerce
	* varray.rb: aliases set_att to put_att
Wed Oct  1  2003  T Horinouchi
	* subsetmapping.rb: debug for the irregular mapping
	* axis.rb: Axis[] was modified to accept NArray and Array
Fri Sep 26  2003  T Horinouchi
	* gphys-0.2.1 released
	* varray.rb,varraycomposite.rb: set_att changed to return self
	* gphys_netcdf_io.rb: support multiple gphys output in a single
	  file
	* testdata/cira86.dat: (added) text file to hold the CIRA86 data
	* sample/cira86_to_nc.rb: converts the CIRA data into NetCDF file
	  via GPhys.
Tue Sep 23  2003  T Horinouchi
	* axis.rb,grid.rb: use sprintf("%g",..) to format lost axis info.
	* varraycomposite.rb: further debug in [].
	* varray.rb: debug for NArray_type3_methods (NArrayMiss handling)
	* gphys_netcdf_io.rb: found bug in missing data handling. Not 
	  fully fixed but disabled -- waiting for the NArrayMiss handling
	  support by RubyDCL.
Mon Sep 22  2003  T Horinouchi
	* axis.rb: to require "numru/gphys/varraycomposite"
	* varraycomposite.rb: support the rubber dim. debug in [].
	* gphys_netcdf_io.rb: NetCDF_IO.open: support multiple files.
	  Added a RD doc.
Thu Sep 18  2003  T Horinouchi
	* gphys-0.2.0 released
	* doc/grads_gridded.html: (generated from grads_gridded.rb)
	* gphys.rb,grid.rb,varray.rb,ggraph.rb: added 3rd&4th args to "eval"
	  for backtrace
Tue Sep 16  2003  R Mizuta
	* gphys_grads_io.rb: (created)
	* varraygrads.rb: (created) 
	* grads_gridded.rb: (created) classes for GrADS gridded datasets
	* testdata/T.jan.dat: (created) GrADS binary data
	* testdata/T.jan.ctl: (created) GrADS control file for T.jan.dat
Wed Sep  3  2003  T Horinouchi
	* gphys.rb: modified GPhys#axis, GPhys#coord to support spec by	name
	* varray.rb: added VArray#file
	* varraynetcdf.rb: added VArrayNetCDF#file
Tue Sep  2  2003  T Horinouchi
	* gphys-0.1.0 released
	* sample/druby_serv2.rb: enhanced to accept a port specified
	* sample/druby_cli2.rb: changed to use the current GGraph.
Fri Aug 29  2003  T Horinouchi
	* axis.rb: renamed Axis#mean to Axis#average, Axis#integ to 
	  Axis#integrate (thus renaming Grid#mean and GPhys#mean
	  to Grid#average and GPhys#average and so on). Test programs are
	  changed accordingly (axis.rb, grid.rb, gphys.rb, ggraph.rb,
	  and ggraph_old.rb).
	* gphys.rb: GPhys#coord added (coord(i) is same as axis(i).pos)
	* grid.rb,gphys.rb: renamed collapsed_axes to lost_axes
	* varray.rb: set VArray#attr private. Defined VArray#(set|get)_att
	  VArray#att_names. Aso changed corresponding to this change are
	  varraynetcdf.rb, axis.rb, coordtransform.rb, grid.rb
	  gphys_netcdf_io.rb, varraycomposite.rb, ggraph.rb ggraph_old.rb
	* varray.rb: added type1 methods such as sort and type2 methods
	  such as mean, min, max. (type2 had been supported)
	  Changed gphys.rb accordingly.
	* gphys.rb: made GPhys#grid protected
Thu Aug 28  2003  T Horinouchi
	* grid.rb: modified Grid::[] to support the rubber dimension
	* gphys.rb: modified GPhys::[] & []= to support the rubber dimension
Thu Aug 28  2003  T Horinouchi
	* gphys-0.0.6 released
Wed Aug 27  2003  T Horinouchi
	* gphys.rb: added RD indexes
	* ggraph.rb: further built and documentation written. Now it has
	  a basic graphic functionality.
Tue Aug 26  2003  T Horinouchi
	* axis.rb: refined Axis#[] (no change in behavior). added Axis#cut*
	* grid.rb: modified Grid#cut* to depend on Axis#cut*
	* ggraph.rb: further built
Mon Aug 25  2003  T Horinouchi
	* gphys.rb: added GPhys#cut*
	* grid.rb: slightly editted
Mon Aug 25  2003  T Horinouchi
	* gphys-0.0.5 released
	* ggraph.rb: slightly enhanced (still underconstruction)
Fri Aug 22  2003  T Horinouchi
	* varray.rb: debug VArray#inspect
	* grid.rb: added Grid#cut, Grid#cut_rank_conserving
	* ggraph.rb: enhanced (with many changes; but still underconstruction)
Wed Aug 20  2003  T Horinouchi
	* gphys.rb: added methods axis and collapsed_axes, so that one
	  does not have to put like gphys.grid.axis(1). Also added is
	  rank, which of course must be.
	* grid.rb: renamed collapsed to collapsed_axes. Updated.
	* ggraph.rb: slightly modified (still underconstruction)
	* ggraph_old.rb: Updated
Tue Aug 19  2003  T Horinouchi
	* sample/druby_cli1.rb,sample/druby_serv1.rb: updated
	* sample/druby_cli2.rb,sample/druby_serv2.rb: created
Sun Aug 11  2003  T Horinouchi
	* gphys-0.0.4 released
	* varray.rb: added documentation; minor changes
	* varraynetcdf.rb,varraycomposite.rb: minor changes
Sun Aug 10  2003  T Horinouchi
	* varraycomposite.rb: made to realize a composite VArray class
	  VArrayComposite.
Fri Aug  8  2003  T Horinouchi
	* varray.rb: minor change in inspect.
	* axis.rb: change implimentation of Axis#mean and Axis#integ
	  --- to simplify the source code and not to use Proc.
	  Also, use of the observer pattern to notify addion of similar
	  methods was eliminated, so to add some has to be done before
	  Grid or GPhys is loaded.
	* grid.rb,gphys.rb: minor changes corresponding to the change in
	  axis.rb (see above).
Mon Jun 23  2003  T Horinouchi
	* gphys-0.0.3 released (although the revision is still
	  underway)
	* start CVS
Jun 12-23  2003  T Horinouchi
	* Many updates such as direcotry reorganization, addition of
	  coord*.rb, debug, etc.etc.
Wed Jun 11  2003  T Horinouchi
	* axis.rb: loc -> pos
	* grid.rb: delete attr_reader axes and define axis/set_axis methods
	* gphys_netcdf_io.rb: define write
Mon Jun  9  2003  T Horinouchi
	* axis.rb,grid.rb,gphys.rb: define copy (I will probably change
	  the name). This is to make a deep clone, which possbly read
	  data in a file (or files) and store them on memoty.
Sun Jun  8  2003  T Horinouchi
	* ggraph.rb: saved and start writing from scratch (far from completed)
Wed May 14  2003  T Horinouchi
	* gphys-0.0.2 released
